#include <stdlib.h>
#include <OneWire.h>
#include <avr/pgmspace.h>
#include <SPI.h>
#include <SD.h>

#include <Time.h>  
#include <Wire.h>  
#include <DS1307RTC.h>  
#include <DS1307.h>
//#include <TimeAlarms.h>
//#define DEBUG 1
#define DEBUG_MAIL_LOGIC 1
//#define DEBUG_BUTTONS 1
//#define DEBUG_PAINT_APP 1
#define DEBUG_SD 1
//#define ECHO_COMMANDS 1
#define DEBUG_BROWSER 1

unsigned int TIME_SHORT = 2999;
unsigned int TIME_LONG = 60999;
unsigned int count = 0;   //used to keep count of how many interrupts were fired
boolean b_stop_loop = false;
unsigned int TIMERCNT = TIME_SHORT;
//Timer2 Overflow Interrupt Vector, called every 1ms
ISR(TIMER2_OVF_vect) {
  count++;               //Increments the interrupt counter
  if(count > TIMERCNT){
    b_stop_loop = true;
    count = 0;           //Resets the interrupt counter
  }
  TCNT2 = 130;           //Reset Timer to 130 out of 255
  TIFR2 = 0x00;          //Timer2 INT Flag Reg: Clear Timer Overflow Flag
};  

void allow_loop( unsigned int _timer )
{
  TIMERCNT = _timer;
  b_stop_loop = false;
}


#define DEST_HOST   "www.your_own_host.de"
#define WHERE_CASA 0
#define WHERE_HOT 1
#define SSID_HOME "Fritz7490_GS"
#define PASS_HOME "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
#define SSID_HOT "M13Hotspot"
#define PASS_HOT "123456789ABCDEFGHIJKLMNOPQR"


#define TIMEOUT     3000 // mS
#define CONTINUE    false
#define HALT        true
#define ALARM_MAIL 1
#define INFO_MAIL 2
#define ONLY_DRAW 1
#define ONLY_PRINT 2
#define DRAW_PRINT 3
const int upload_iter = 5000;
int upload_cnt = 0;

char dummy = 'D';

boolean connection_established = false;
boolean last_drawn_status = connection_established;
int where_connected = -1;
#define LAST_SEND 0
#define LAST_RECEIVE 1
int last_wifi_opeartion = -1;

//#include <tinyFAT.h>
//#include <UTFT_tinyFAT.h>
#include <UTFT.h>
#include <UTouch.h>

extern unsigned int mail[0x1024];
extern unsigned int pincel[0x1024];
extern unsigned int ok[0x1024];
extern unsigned int schwam[0x1024];
extern unsigned int keanu[0x1024];
extern unsigned int kilian[0x1024];
extern unsigned int samira[0x1024];
extern unsigned int mjesus[0x1024];
extern unsigned int mami[0x1024];
extern unsigned int andreas[0x1024];
extern unsigned int juanito[0x1024];
extern unsigned int javier[0x1024];
extern unsigned int getmail[0x1024];
extern unsigned int arcoiris[0x1024];
extern unsigned int clock[0x576];
extern unsigned int Desktop[0x576];
extern unsigned int hand[0x1024];
//extern unsigned int ninosk[0x19200];


// Initialize display
// ------------------
// Set the pins to the correct ones for your development board
// -----------------------------------------------------------
// Standard Arduino Uno/2009 Shield            : <display model>,19,18,17,16
// Standard Arduino Mega/Due shield            : <display model>,38,39,40,41
// CTE TFT LCD/SD Shield for Arduino Due       : <display model>,25,26,27,28
// Teensy 3.x TFT Test Board                   : <display model>,23,22, 3, 4
// ElecHouse TFT LCD/SD Shield for Arduino Due : <display model>,22,23,31,33
//
// Remember to change the model parameter to suit your display module!
UTFT    myGLCD(ITDB32S,38,39,40,41);

//UTFT_tinyFAT myFiles(&myGLCD);
//char* files320[]={"/fotos/ninos.raw"};

// Initialize touchscreen
// ----------------------
// Set the pins to the correct ones for your development board
// -----------------------------------------------------------
// Standard Arduino Uno/2009 Shield            : 15,10,14, 9, 8
// Standard Arduino Mega/Due shield            :  6, 5, 4, 3, 2
// CTE TFT LCD/SD Shield for Arduino Due       :  6, 5, 4, 3, 2
// Teensy 3.x TFT Test Board                   : 26,31,27,28,29
// ElecHouse TFT LCD/SD Shield for Arduino Due : 25,26,27,29,30
//
UTouch  myTouch( 6, 5, 4, 3, 2);

// Declare which fonts we will be using
extern uint8_t BigFont[];
extern uint8_t SmallFont[];
//extern uint8_t various_symbols[];
//extern uint8_t Dingbats1_XL[];
extern uint8_t Sinclair_S[];

int x, y;
#define MSG_ROW_LEN 20
char stCurrent[MSG_ROW_LEN]="";
int stCurrentLen=0;
char stLast[MSG_ROW_LEN]="";
char stLast2[MSG_ROW_LEN]="";
char stLast3[MSG_ROW_LEN]="";

/*************************
**   Custom functions   **
*************************/
#define LETTERS_KEY_SERARATION 7
#define SYMBOLS_KEY_SEPARATION 14
boolean upper_case = false;
boolean letter_font = true;
int key_size = 30;
int icon_size = 40;
int pic_size_y = 66;
int pic_size_x = 88;
int key_separation = LETTERS_KEY_SERARATION;
int icon_separation = 25;
int row_elem = 10;


char *key_no_key[1] = {"N"};
char *key_strg[1] = {"Str"};
char *key_del[1] = {"del"};
char key_space[1][4] = {"   "};
char *key_clear[1] = {"   "};
char *key_enter[1] = {"OK"};
char *key_send[1] = {"@"};
char *key_getmail[1] = {"?"};
char *key_font[1] = {"#"};

#define SENDER_CNT 3
char *key_sendername[SENDER_CNT] = { "Samira", "Kilian", "Keanu" };
unsigned int *icon_sendername[SENDER_CNT] = {samira, kilian, keanu};
//char *key_sendername[SENDER_CNT] = { "Keanu", "Samira", "Kilian" };
//unsigned int *icon_sendername[SENDER_CNT] = {keanu, samira, kilian};
int sendername_index = 0;
int sendername_button_nr = -1;
File inbox[SENDER_CNT];
time_t last_check[SENDER_CNT] = {0,0,0};

#define MAX_MAILS 4
typedef struct {
  String mail_text;
  String att_file_name;
  String from;
}mail_unit;
typedef struct {
  mail_unit mail_array[MAX_MAILS];
}mailbox;
mailbox mails;


#define MAILTO_CNT 8
int mailto_cnt = MAILTO_CNT;
char *key_mailto[10] =                  {"Mama", "Papa", "Keanu", "Kilian", "Samira", "Mami", "Juanito", "Javier"};
unsigned int *icon_mailto[MAILTO_CNT] = {mjesus, andreas, keanu,   kilian,   samira,   mami, juanito, javier};
int mailto_index = 0;
int mailto_button_nr = -1;

char *key_first_row[10] = {"1","2","3","4","5","6","7","8","9","0"};
char *key_second_row[10] = {"q", "w", "e", "r", "t", "z", "u", "i", "o", "p"};
char *keyS_second_row[10] = {"Q", "W", "E", "R", "T", "Z", "U", "I", "O", "P"};
char *key_third_row[10] = {"a", "s", "d", "f", "g", "h", "j", "k", "l", "u"};
char *keyS_third_row[10] = {"A", "S", "D", "F", "G", "H", "J", "K", "L", "U"};
char *key_forth_row[10] = {"y", "x", "c", "v", "b", "n", "m", "?", "o", "a"};
char *keyS_forth_row[10] = {"Y", "X", "C", "V", "B", "N", "M", "?", "O", "A"};

int key_pos = 12;
int first_row_y = 10;
int key_offset = key_pos - first_row_y; 
int row_y_distance = key_size + first_row_y ;
boolean key_positions_printed = false;
int strg_button_nr = -1;
int del_button_nr = -1;
int enter_button_nr = -1;
int clear_button_nr = -1;
int send_button_nr = -1;
int getmail_button_nr = -1;
int paint_button_nr = -1;
int font_button_nr = -1;
int browser_button_nr = -1;
int last_letters_button_nr = -1;
int ok_mails_button_nr = -1;
int getmail_mails_button_nr = -1;
int change_user_mails_button_nr = -1;
int image_to_send_button_nr = -1;
int ok_browser_button_nr = -1;
int next_browser_button_nr = -1;

#define MAX_BUTTON_CNT 60
int fields_amount = 50;
typedef struct {
  int x1;
  int y1;
  int x2;
  int y2;
  char *pt;
  unsigned int *pimage;
  boolean set_done;
  boolean special_char;    
  int mail_index;
  String file_name;
} FieldPos;
FieldPos fields[MAX_BUTTON_CNT];

bool set_field(int& _button_nr , int _x1, int _y1, int _x2, int _y2,                
               char *_pt = NULL, unsigned int *_pimage = NULL, bool _sp = false, 
               int _mi=-1, String _fn="")
               {
                 if( _button_nr > MAX_BUTTON_CNT )
                   return false;
                   
                 _button_nr++;
                 
                 if( fields[_button_nr].set_done == false )
                 {
                   fields[_button_nr].x1 = _x1;
                   fields[_button_nr].y1 = _y1;
                   fields[_button_nr].x2 = _x2;
                   fields[_button_nr].y2 = _y2;
                   fields[_button_nr].pt = _pt;
                   fields[_button_nr].pimage = _pimage;
                   fields[_button_nr].set_done = true;
                   fields[_button_nr].special_char = _sp;
                   fields[_button_nr].mail_index = _mi;                   
                 }
                 fields[_button_nr].file_name = _fn;                 
                 return true;
               }

#define KEYBOARD_ALL 0
#define KEYBOARD_ONLY_LETTERS 1
void init_fields_pos( int init_keys = KEYBOARD_ALL )
{
  int end_key = MAX_BUTTON_CNT;
  if( init_keys == KEYBOARD_ONLY_LETTERS )
    end_key = last_letters_button_nr;
  for( int i=0; i<= end_key && i<MAX_BUTTON_CNT ; i++)
  {
    fields[i].x1 = -1;
    fields[i].y1 = -1;
    fields[i].x2 = -1;
    fields[i].y2 = -1;
    fields[i].pt = key_no_key[0];
    fields[i].set_done = false;
    fields[i].special_char = false;
    fields[i].pimage = NULL;
    fields[i].file_name = "";
    fields[i].mail_index = -1;
  }
}



/*********************** Paint ***************************************************************************/
int color = 0;
word colorlist[] = {VGA_WHITE, VGA_BLACK, VGA_RED, VGA_BLUE, VGA_GREEN, VGA_FUCHSIA, VGA_YELLOW, VGA_AQUA};
int  bsize = 4;
File curr_image;
int  curr_image_index = -1;
char info_file[10] = {"info.txt"};
int last_used_color = -1;
char image_to_send[20] = {""};



/***********************PAGES*******************************************/
#define KEYBOARD_PAGE 0
#define PAINT_PAGE 1
#define MAILS_PAGE 2
#define PICTURE_PAGE 3
#define CLOCK_PAGE 4
#define BROWSER_PAGE 5
int iPAGE = KEYBOARD_PAGE;
#define IMAGE_SEND_BAR_OK 0
#define IMAGE_SEND_BAR_ERROR 1
#define IMAGE_SEND_BAR_WAIT 2
#define IMAGE_SEND_BAR_CLEAN 3

/***********************************************************************/


/**********************MAILS********************************************/
#define MAX_MAIL_CNT 4  // 36pxiel x 4 = 144

int image_selected = -1;
char MAILSFILE[] = "mails.txt";
bool  last_connect_status = false;

void set_conn_status( bool conn_status )
{
#ifdef DEBUG_MAIL_LOGIC
  Serial.print(F("Set Status to "));Serial.println((conn_status==true)?"1":"0");
#endif  
  last_connect_status = conn_status;
}
bool newmail = false;
bool newmail_drawn = false;
/***********************************************************************/


/**********************CLOCK********************************************/
#define DS1307_ADDRESS 0x68
#define VT100_MODE  1
// Init the DS1307
DS1307 rtc(20, 21);
// Init a Time-data structure
Time  t;
int clockCenterX=119;
int clockCenterY=119;
int oldsec=0;
/***********************************************************************/



/**********************BROWSER******************************************/
#define MAX_PICS 9
/***********************************************************************/

/**********************ACTIVITY*****************************************/
int tlu = -1;  //time of last use of tft
/***********************************************************************/



char poss_key[] = "!§$%&/()=?<>,.-;:_#'+*~ß? ";




void DrawConnectionStatus( boolean force = false )
{
  if( last_drawn_status == connection_established && !force )
    return;
  if( connection_established == true )
  {
    myGLCD.setColor(0, 255, 0);
    myGLCD.fillRoundRect (305, 10, 310, 220);
    myGLCD.setColor(255, 255, 255);
    myGLCD.drawRoundRect (305, 10, 310, 220);
  }
  else
  {
    myGLCD.setColor(255, 0, 0);
    myGLCD.fillRoundRect (305, 10, 310, 220);
    myGLCD.setColor(255, 255, 255);
    myGLCD.drawRoundRect (305, 10, 310, 220);
  }  
  last_drawn_status = connection_established;
}

///////////////////////////////DRAW BUTTONS//////////////////////////////////////////
void DrawButtons(int init_keys = KEYBOARD_ALL )
{
  if( init_keys == KEYBOARD_ALL )
    myGLCD.clrScr(); 
  myTouch.InitTouch();  
  myTouch.setPrecision(PREC_MEDIUM);
  
  int old_fields_amount = fields_amount;
  
  int button_nr = 0;
// Draw the upper row of buttons
  int row_index = 0;
  int last_y = 0;
  for( row_index = 0; row_index < row_elem; row_index++ )
  {
    myGLCD.setColor(0, 0, 255);
    myGLCD.fillRoundRect (key_separation+(row_index*key_size), first_row_y, key_size+(row_index*key_size), key_size);
    myGLCD.setColor(255, 255, 255);
    myGLCD.drawRoundRect (key_separation+(row_index*key_size), first_row_y, key_size+(row_index*key_size), key_size);
    myGLCD.print(key_first_row[row_index], key_pos+(row_index*key_size), key_pos);
    set_field(button_nr , 
              key_separation+(row_index*key_size), 
              first_row_y, 
              key_size+(row_index*key_size), 
              key_size, 
              key_first_row[row_index]);    
  }
  last_y = key_size;

  for( row_index = 0; row_index < row_elem; row_index++ )
  {
    myGLCD.setColor(0, 0, 255);
    myGLCD.fillRoundRect (key_separation+(row_index*key_size), 
                          last_y+key_separation, 
                          key_size+(row_index*key_size), 
                          last_y+key_separation+(key_size-first_row_y));                          
    myGLCD.setColor(255, 255, 255);
    myGLCD.drawRoundRect (key_separation+(row_index*key_size), 
                          last_y+key_separation, 
                          key_size+(row_index*key_size), 
                          last_y+key_separation+(key_size-first_row_y));
    if( upper_case == true )                          
      myGLCD.print(keyS_second_row[row_index], key_pos+(row_index*key_size), last_y+key_separation+key_offset);  
    else   
      myGLCD.print(key_second_row[row_index], key_pos+(row_index*key_size), last_y+key_separation+key_offset);  
      
    if( upper_case == true )  
      set_field(button_nr , 
                key_separation+(row_index*key_size), 
                last_y+key_separation, 
                key_size+(row_index*key_size), 
                last_y+key_separation+(key_size-first_row_y), 
                keyS_second_row[row_index]);
    else            
      set_field(button_nr , 
                key_separation+(row_index*key_size), 
                last_y+key_separation, 
                key_size+(row_index*key_size), 
                last_y+key_separation+(key_size-first_row_y), 
                key_second_row[row_index]);        
  }
  last_y += key_separation+(key_size-first_row_y);

  for( row_index = 0; row_index < row_elem; row_index++ )
  {   
    myGLCD.setColor(0, 0, 255);
    myGLCD.fillRoundRect (key_separation+(row_index*key_size), 
                          last_y+key_separation, 
                          key_size+(row_index*key_size), 
                          last_y+key_separation+(key_size-first_row_y));                          
    myGLCD.setColor(255, 255, 255);
    myGLCD.drawRoundRect (key_separation+(row_index*key_size), 
                          last_y+key_separation, 
                          key_size+(row_index*key_size), 
                          last_y+key_separation+(key_size-first_row_y));   
                          
    boolean spec_char = false;
    if( row_index == row_elem - 1 )
    {
      myGLCD.setColor(255, 0, 0);
      spec_char = true;
    }
    if( upper_case == true )  
      myGLCD.print(keyS_third_row[row_index], key_pos+(row_index*key_size), last_y+key_separation+key_offset);   
    else  
      myGLCD.print(key_third_row[row_index], key_pos+(row_index*key_size), last_y+key_separation+key_offset);   
      
    if( upper_case == true )  
      set_field(button_nr , 
                key_separation+(row_index*key_size), 
                last_y+key_separation, 
                key_size+(row_index*key_size), 
                last_y+key_separation+(key_size-first_row_y), 
                keyS_third_row[row_index],NULL, spec_char);
    else            
      set_field(button_nr , 
                key_separation+(row_index*key_size), 
                last_y+key_separation, 
                key_size+(row_index*key_size), 
                last_y+key_separation+(key_size-first_row_y), 
                key_third_row[row_index], NULL, spec_char);                
  }
  last_y += key_separation+(key_size-first_row_y);
  
  for( row_index = 0; row_index < row_elem; row_index++ )
  {
    myGLCD.setColor(0, 0, 255);
    myGLCD.fillRoundRect (key_separation+(row_index*key_size), 
                          last_y+key_separation, 
                          key_size+(row_index*key_size), 
                          last_y+key_separation+(key_size-first_row_y));                          
    myGLCD.setColor(255, 255, 255);
    myGLCD.drawRoundRect (key_separation+(row_index*key_size), 
                          last_y+key_separation, 
                          key_size+(row_index*key_size), 
                          last_y+key_separation+(key_size-first_row_y));   
                          
    boolean spec_char = false;                          
    if( row_index >= row_elem - 2 )
    {
      myGLCD.setColor(255, 0, 0);
      spec_char = true;
    }
    if( upper_case == true )
      myGLCD.print(keyS_forth_row[row_index], key_pos+(row_index*key_size), last_y+key_separation+key_offset);   
    else
      myGLCD.print(key_forth_row[row_index], key_pos+(row_index*key_size), last_y+key_separation+key_offset);   
      
    if( upper_case == true )  
      set_field(button_nr , 
                key_separation+(row_index*key_size), 
                last_y+key_separation, 
                key_size+(row_index*key_size), 
                last_y+key_separation+(key_size-first_row_y), 
                keyS_forth_row[row_index],NULL, spec_char);
    else            
      set_field(button_nr , 
                key_separation+(row_index*key_size), 
                last_y+key_separation, 
                key_size+(row_index*key_size), 
                last_y+key_separation+(key_size-first_row_y), 
                key_forth_row[row_index], NULL, spec_char);                      
   fields_amount = button_nr;             
  }
  last_letters_button_nr = button_nr;
  
  
  
  if( init_keys == KEYBOARD_ONLY_LETTERS ) //If we only print the A-Z and 0-9 keys
  {
    fields_amount = old_fields_amount;
    return;
  }

  /******************* STRG BUTTON **************************/
  last_y += key_separation+(key_size-first_row_y);
  myGLCD.setColor(255, 0, 0);
  myGLCD.fillRoundRect (key_separation, 
                        last_y+key_separation, 
                        key_size+(1*key_size), 
                        last_y+key_separation+(key_size-first_row_y));                          
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect (key_separation, 
                        last_y+key_separation, 
                        key_size+(1*key_size), 
                        last_y+key_separation+(key_size-first_row_y));  
  if( upper_case == true  )
    myGLCD.setColor(255, 0, 0);
    
  //myGLCD.print("Str", key_pos, last_y+key_separation+key_offset);  
  set_field(button_nr , 
            key_separation, 
            last_y+key_separation, 
            key_size+(1*key_size), 
            last_y+key_separation+(key_size-first_row_y), 
            key_strg[0], NULL, true);   
  fields_amount = button_nr;
  strg_button_nr = button_nr;            
  
  /******************* SPACE BUTTON **************************/  
  myGLCD.setColor(0, 0, 255);
  myGLCD.fillRoundRect (key_separation+(2*key_size), 
                        last_y+key_separation, 
                        (6*key_size), 
                        last_y+key_separation+(key_size-first_row_y));                          
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect (key_separation+(2*key_size), 
                        last_y+key_separation, 
                        (6*key_size), 
                        last_y+key_separation+(key_size-first_row_y));  
  set_field(button_nr , 
            key_separation+(2*key_size), 
            last_y+key_separation, 
            (6*key_size), 
            last_y+key_separation+(key_size-first_row_y), 
            key_space[0]);      
  fields_amount = button_nr;              

  /******************* DEL BUTTON **************************/  
  myGLCD.setColor(0, 0, 255);
  myGLCD.fillRoundRect (key_separation+(6*key_size), 
                        last_y+key_separation, 
                        (8*key_size), 
                        last_y+key_separation+(key_size-first_row_y));                          
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect (key_separation+(6*key_size), 
                        last_y+key_separation, 
                        (8*key_size), 
                        last_y+key_separation+(key_size-first_row_y));  
  myGLCD.print(key_del[0], key_pos+(6*key_size), last_y+key_separation+key_offset);  
  set_field(button_nr , 
            key_separation+(6*key_size), 
            last_y+key_separation, 
            (8*key_size), 
            last_y+key_separation+(key_size-first_row_y), 
            key_del[0]);          
  fields_amount = button_nr;
  del_button_nr = button_nr;  
  
  /******************* BROWSER BUTTON **************************/  
  myGLCD.drawBitmap( key_separation+(8*key_size), last_y+key_separation, 24, 24, Desktop);                         
  set_field(button_nr , 
            key_separation+(8*key_size), 
            last_y+key_separation, 
            key_separation+(8*key_size)+24,
            last_y+key_separation +24,
            key_font[0], Desktop);     
  fields_amount = button_nr;
  browser_button_nr = button_nr;   
  
  /******************* FONT BUTTON **************************/  
  myGLCD.drawBitmap( key_separation+(9*key_size), last_y+key_separation, 24, 24, clock);                         
  set_field(button_nr , 
            key_separation+(9*key_size), 
            last_y+key_separation, 
            key_separation+(9*key_size)+24, 
            last_y+key_separation +24, 
            key_font[0], clock);     
  fields_amount = button_nr;
  font_button_nr = button_nr;    //now used for clock
  /****************************  KEYBOARD END  *********************************/  
  
  
  
  
  /****************** FUNCTION KEYS ********************************************/
  /******  ROW 1 ******/  
  last_y += key_separation+(key_size-first_row_y);

  /******************* GETMAIL BUTTON **************************/  
  myGLCD.drawBitmap( icon_separation+(3*icon_size), last_y+key_separation, 32, 32, getmail); 
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect (icon_separation+(3*icon_size), 
                        last_y+key_separation, 
                        icon_separation+(3*icon_size)+32, 
                        last_y+key_separation+32);  
  set_field(button_nr , 
            icon_separation+(3*icon_size), 
            last_y+key_separation, 
            icon_separation+(3*icon_size)+32, 
            last_y+key_separation+32, 
            key_getmail[0], getmail);        
  fields_amount = button_nr;
  getmail_button_nr = button_nr;  
 #ifdef DEBUG_BUTTONS 
  Serial.print(F("GetMail button nr "));Serial.println(getmail_button_nr);
 #endif 
 
  /******************* SENDERNAME BUTTON **************************/    
  myGLCD.drawBitmap( icon_separation+(4*icon_size), last_y+key_separation, 32, 32, icon_sendername[sendername_index]);
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect (icon_separation+(4*icon_size), 
                        last_y+key_separation, 
                        icon_separation+(4*icon_size)+32, 
                        last_y+key_separation+32);                          
  set_field(button_nr , 
            icon_separation+(4*icon_size), 
            last_y+key_separation, 
            icon_separation+(4*icon_size)+32, 
            last_y+key_separation+32, 
            key_sendername[sendername_index]);  
  fields_amount = button_nr;
  sendername_button_nr = button_nr;  
 #ifdef DEBUG_BUTTONS 
  Serial.print(F("Sender Namer button nr "));Serial.println(sendername_button_nr);
 #endif             
  
  /******************* SEND BUTTON **************************/  
  myGLCD.drawBitmap( icon_separation+(5*icon_size), last_y+key_separation, 32, 32, mail);                        
  myGLCD.setColor(0, 255, 0);
  myGLCD.drawRoundRect (icon_separation+(5*icon_size), 
                        last_y+key_separation, 
                        icon_separation+(5*icon_size)+32, 
                        last_y+key_separation+32);                          
  set_field(button_nr , 
            icon_separation+(5*icon_size), 
            last_y+key_separation, 
            icon_separation+(5*icon_size)+32, 
            last_y+key_separation+32, 
            key_send[0], mail); 
  fields_amount = button_nr;
  send_button_nr = button_nr;              
 #ifdef DEBUG_BUTTONS 
  Serial.print(F("Send button nr "));Serial.println(send_button_nr);
 #endif             
  /******************* MAILTO BUTTON **************************/    
  myGLCD.drawBitmap( icon_separation+(6*icon_size), last_y+key_separation, 32, 32, icon_mailto[mailto_index]);
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect (icon_separation+(6*icon_size), 
                        last_y+key_separation, 
                        icon_separation+(6*icon_size)+32, 
                        last_y+key_separation+32);  
  set_field(button_nr , 
            icon_separation+(6*icon_size), 
            last_y+key_separation, 
            icon_separation+(6*icon_size)+32, 
            last_y+key_separation+32, 
            key_sendername[mailto_index]);  
  fields_amount = button_nr;
  mailto_button_nr = button_nr;              
 #ifdef DEBUG_BUTTONS 
  Serial.print(F("MailTo button nr "));Serial.println(mailto_button_nr);
 #endif  
  /******  ROW 2 ******/  
  last_y += icon_separation-15+(icon_size-first_row_y);
  
  /******************* CLEAR BUTTON **************************/   
  myGLCD.drawBitmap( icon_separation+(3*icon_size), last_y+key_separation, 32, 32, schwam);
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect (icon_separation+(3*icon_size), 
                        last_y+key_separation, 
                        icon_separation+(3*icon_size)+32, 
                        last_y+key_separation+32);  
  set_field(button_nr , 
            icon_separation+(3*icon_size), 
            last_y+key_separation, 
            icon_separation+(3*icon_size)+32, 
            last_y+key_separation+32, 
            key_clear[0], schwam);  
  fields_amount = button_nr;
  clear_button_nr = button_nr;              
 #ifdef DEBUG_BUTTONS 
  Serial.print(F("Clear button nr "));Serial.println(clear_button_nr);  
 #endif   
 
  /******************* ENTER BUTTON **************************/  
  myGLCD.drawBitmap( icon_separation+(4*icon_size), last_y+key_separation, 32, 32, ok); 
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect (icon_separation+(4*icon_size), 
                        last_y+key_separation, 
                        icon_separation+(4*icon_size)+32, 
                        last_y+key_separation+32);    
  set_field(button_nr , 
            icon_separation+(4*icon_size), 
            last_y+key_separation, 
            icon_separation+(4*icon_size)+32, 
            last_y+key_separation+32, 
            key_enter[0], ok);                          
  fields_amount = button_nr;
  enter_button_nr = button_nr;              
 #ifdef DEBUG_BUTTONS 
  Serial.print(F("Enter button nr "));Serial.println(enter_button_nr);
 #endif 
 
  /******************* PAINT BUTTON **************************/   
  myGLCD.drawBitmap( icon_separation+(5*icon_size), last_y+key_separation, 32, 32, pincel);  
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect (icon_separation+(5*icon_size), 
                        last_y+key_separation, 
                        icon_separation+(5*icon_size)+32, 
                        last_y+key_separation+32);  
  set_field(button_nr , 
            icon_separation+(5*icon_size), 
            last_y+key_separation, 
            icon_separation+(5*icon_size)+32, 
            last_y+key_separation+32, 
            key_clear[0], pincel);                          
  fields_amount = button_nr;
  paint_button_nr = button_nr;  
 #ifdef DEBUG_BUTTONS 
  Serial.print(F("Paint button nr "));Serial.println(paint_button_nr);  
 #endif             

  /******************* IMAGE BUTTON **************************/   
  if( strlen(image_to_send) > 5 )
    myGLCD.drawBitmap( icon_separation+(6*icon_size), last_y+key_separation, 32, 32, arcoiris);    
  else
  {
    myGLCD.setColor(230, 80, 10);
    myGLCD.fillRoundRect (icon_separation+(6*icon_size), 
                        last_y+key_separation, 
                        icon_separation+(6*icon_size)+32, 
                        last_y+key_separation+32);         
  }
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect (icon_separation+(6*icon_size), 
                        last_y+key_separation, 
                        icon_separation+(6*icon_size)+32, 
                        last_y+key_separation+32);   

  set_field(button_nr , 
            icon_separation+(6*icon_size), 
            last_y+key_separation, 
            icon_separation+(6*icon_size)+32, 
            last_y+key_separation+32, 
            NULL, arcoiris);   
  fields_amount = button_nr;
  image_to_send_button_nr = button_nr;  
 #ifdef DEBUG_BUTTONS 
  Serial.print(F("Paint button nr "));Serial.println(image_to_send_button_nr);  
 #endif   

  /******  ROW 3 ******/  
  last_y += key_separation+(key_size-first_row_y);  

  debug_button_positions();
  
}

void debug_button_positions( )
{
 #ifdef DEBUG_BUTTONS_"
  if( key_positions_printed == true )
    return;
  Serial.print(F("FIELDS "));Serial.println(fields_amount);
  for( int i=1; i<= fields_amount; i++ )
  {
    Serial.print(F("Field "));Serial.print(i);
    Serial.print(F(" -> "));Serial.print(fields[i].x1);
    Serial.print(F(","));Serial.print(fields[i].y1);
    Serial.print(F(","));Serial.print(fields[i].x2);
    Serial.print(F(","));Serial.print(fields[i].y2);
    Serial.print(F("     Char="));Serial.print(fields[i].pt[0]);
    Serial.print(F("     Spec="));Serial.println(fields[i].special_char);    
  }
  key_positions_printed = true;
 #endif 
}


void draw_one_button( int button_nr, char* text)
{
  if( button_nr == image_to_send_button_nr )
    myGLCD.setColor(230, 80, 10);
  else  
    myGLCD.setColor(0, 0, 255);
    
  myGLCD.fillRoundRect (fields[button_nr].x1, fields[button_nr].y1,
                        fields[button_nr].x2, fields[button_nr].y2);                          
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect (fields[button_nr].x1, fields[button_nr].y1,
                        fields[button_nr].x2, fields[button_nr].y2);   
}


void draw_icon( int button_nr, unsigned int *icon_image )
{  
    //myGLCD.drawBitmap( fields[button_nr].x1, fields[button_nr].y1, 32, 32, fields[button_nr].pimage);
    myGLCD.drawBitmap( fields[button_nr].x1, fields[button_nr].y1, 32, 32, icon_image);
    myGLCD.setColor(255, 255, 255);
    myGLCD.drawRoundRect (fields[button_nr].x1, 
                          fields[button_nr].y1, 
                          fields[button_nr].x1+32, 
                          fields[button_nr].y1+32);      
}

void draw_function_icons()
{
  draw_icon( clear_button_nr, fields[clear_button_nr].pimage );
  draw_icon( enter_button_nr, fields[enter_button_nr].pimage );
  draw_icon( paint_button_nr, fields[paint_button_nr].pimage );
  draw_icon( getmail_button_nr, fields[getmail_button_nr].pimage );              
  draw_icon( sendername_button_nr, icon_sendername[sendername_index] );    
  draw_icon( mailto_button_nr, icon_mailto[mailto_index] );        
  draw_icon( send_button_nr, fields[send_button_nr].pimage );  
  if( strlen(image_to_send) > 5 )
    draw_icon( image_to_send_button_nr, fields[image_to_send_button_nr].pimage );  
  else
    draw_one_button ( image_to_send_button_nr, "");    
  DrawConnectionStatus( true );  
}


void draw_saved_text( )
{
  if( strlen(stLast3) > 0 )
    myGLCD.print(stLast3, LEFT, 172);
  if( strlen(stLast2) > 0 )    
    myGLCD.print(stLast2, LEFT, 190);
  if( strlen(stLast) > 0 )   
    myGLCD.print(stLast, LEFT, 208);
  if( strlen(stCurrent) > 0 )   
    myGLCD.print(stCurrent, LEFT, 224);
}

void what_do_you_want( )
{  
    DrawConnectionStatus();
    if (myTouch.dataAvailable())
    {
      stlu();
      myTouch.read();
      x=myTouch.getX();
      y=myTouch.getY();
      
      for( int i=1; i<= fields_amount; i++ )
      {
        if( y>=fields[i].y1 && y<=fields[i].y2 && x>=fields[i].x1 && x<=fields[i].x2 )
        {
          waitForIt( fields[i].x1, fields[i].y1, fields[i].x2, fields[i].y2 );
          if( i == strg_button_nr )
          {
            if( upper_case == true )
              upper_case = false;
            else
              upper_case = true;
            myGLCD.setBackColor(0, 0, 255);  
            init_fields_pos(KEYBOARD_ONLY_LETTERS);  
            DrawButtons(KEYBOARD_ONLY_LETTERS);  
          }
          else if( i == del_button_nr )
          {
            stCurrentLen--;            
            stCurrent[stCurrentLen]='\0';
            myGLCD.setColor(0, 0, 0);
            myGLCD.fillRect(0, 224, 319, 239);   
            myGLCD.setColor(0, 255, 0);
            myGLCD.print(stCurrent, LEFT, 224);            
          }
          else if( i == font_button_nr )
          {
            /*
            if( letter_font == true )
            {
              myGLCD.setFont(various_symbols);
              letter_font = false;
            }
            else
            {
              myGLCD.setFont(BigFont);
              letter_font = true;
            }  
            myGLCD.setBackColor(0, 0, 255);  
            init_fields_pos(KEYBOARD_ONLY_LETTERS);  
            DrawButtons(KEYBOARD_ONLY_LETTERS);*/
            DrawClockPage( );
          }      
          else if ( i == browser_button_nr )
            change_page( BROWSER_PAGE );
          else if( i== clear_button_nr)
          {
            stCurrent[0]='\0';
            stCurrentLen=0;
            stLast[0] = '\0';
            stLast2[0] = '\0';
            stLast3[0] = '\0';
            myGLCD.setColor(0, 0, 0);
            myGLCD.fillRect(0, 171, 319, 239);  
            draw_function_icons();          
          }
          else if( i== paint_button_nr)
          {
            change_page( PAINT_PAGE );                       
          }          
          else if( i == sendername_button_nr )
          {
            sendername_index++;
            if( sendername_index == SENDER_CNT )
              sendername_index = 0;
            myGLCD.drawBitmap( fields[i].x1, fields[i].y1,32,32, icon_sendername[sendername_index]) ;  
            //draw_one_button( sendername_button_nr, key_sendername[sendername_index], false );  
            myGLCD.setColor(255, 255, 255);
            myGLCD.drawRoundRect (fields[i].x1, fields[i].y1, fields[i].x2, fields[i].y2);                           
          }
          else if( i == mailto_button_nr )
          {
            mailto_index++;
            if( mailto_index == mailto_cnt )
              mailto_index = 0;
            myGLCD.drawBitmap( fields[i].x1, fields[i].y1,32,32, icon_mailto[mailto_index]);
            myGLCD.setColor(255, 255, 255);
            myGLCD.drawRoundRect (fields[i].x1, fields[i].y1, fields[i].x2, fields[i].y2);
            //draw_one_button( mailto_button_nr, key_mailto[mailto_index], true );                                    
          }          
          else if( i == send_button_nr )
          {
            boolean mail_sent = false;            
            boolean force_connect = send_to_php_IMAGE();
            int try_cnt = 4;
            if( force_connect == false )
            {
              try_cnt = 2;
              DrawImageSendBar(2, 2, IMAGE_SEND_BAR_CLEAN); 
              //DrawImageSendBar(1,2, IMAGE_SEND_BAR_ERROR);            
            }              
            force_connect = false;
            while( !mail_sent && (try_cnt--) > 0)
            {
            #ifdef DEBUG_MAIL_LOGIC 
              Serial.print(F("Send Mail with force connect "));Serial.println(force_connect); 
            #endif                
              mail_sent = send_to_php_MAIL(force_connect);
              if( !mail_sent )
              {
                DrawImageSendBar(2,2, IMAGE_SEND_BAR_ERROR); 
                force_connect = true;              
              }
            }
            CloseConn();
            DrawImageSendBar(2, 2, IMAGE_SEND_BAR_CLEAN); 
            
            stCurrent[0]='\0';
            stCurrentLen=0;
            stLast[0] = '\0';
            stLast2[0] = '\0';
            stLast3[0] = '\0';
            myGLCD.setColor(0, 0, 0);
            myGLCD.fillRect(0, 171, 319, 239);    
            image_to_send[0]='\0';
            draw_function_icons();            
          }                              
          else if( i == enter_button_nr )
          {
            if (stCurrentLen>0)
            {
              for (x=0; x<stCurrentLen+1; x++)
              {
                stLast3[x]=stLast2[x];
                stLast2[x]=stLast[x];
                stLast[x]=stCurrent[x];
              }
              stCurrent[0]='\0';
              stCurrentLen=0;
              myGLCD.setColor(0, 0, 0);
              myGLCD.fillRect(0, 208, 319, 239);
              myGLCD.setColor(255, 0, 0);
              myGLCD.print(stLast3, LEFT, 172);
              myGLCD.print(stLast2, LEFT, 190);
              myGLCD.print(stLast, LEFT, 208);
              draw_function_icons();
            } 
          }
          else if( i == getmail_button_nr )
          { /*              
            if( ReceiveMail(-1) == false )
            {
              reinit_wifi();
              ReceiveMail(-1);
            }
            DrawImageSendBar(2, 2, IMAGE_SEND_BAR_CLEAN);*/
            change_page( MAILS_PAGE );                                               
          }                    
          else if( i == image_to_send_button_nr )          
          {
          }
          else
            updateStr( (char)(fields[i].pt[0]) );
        }
      }      
    }
    else
    {
      otlu();
      if( newmail == true && !newmail_drawn)
      {
        myGLCD.setColor(0, 255, 255);
        myGLCD.print("M", RIGHT, 226);        
        newmail_drawn = true;
      }        
    }
}

void updateStr(int val)
{
  if (stCurrentLen<MSG_ROW_LEN)
  {
    stCurrent[stCurrentLen]=val;
    stCurrent[stCurrentLen+1]='\0';
    stCurrentLen++;
    myGLCD.setColor(255, 0, 0);
    myGLCD.print(stCurrent, LEFT, 224);
  }
}

// Draw a red frame while a button is touched
void waitForIt(int x1, int y1, int x2, int y2)
{
  myGLCD.setColor(255, 0, 0);
  myGLCD.drawRoundRect (x1, y1, x2, y2);
  while (myTouch.dataAvailable())
  {
    stlu();
    myTouch.read();
  }
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect (x1, y1, x2, y2);
}



#define MAILS_SEPARATION 4
#define START_X_MAILFIELD 10
#define MAIL_FIELD_SIZE_X 290
#define MAIL_FIELD_SIZE_Y 36
#define MAIL_BANNER_SIZE_Y 36

#define SIZE_OF_LINE 32
void DrawMailsPage( )
{  
  if( iPAGE != MAILS_PAGE )
    return;
    
  read_inbox( sendername_index );
  newmail = false;  
    
  myGLCD.clrScr();
  //myTouch.InitTouch();
  myTouch.setPrecision(PREC_MEDIUM);
  myGLCD.setFont(BigFont);
  myGLCD.setBackColor(0, 0, 255);  
  
  int button_nr = 0;
  int last_y = 10;
  
  /******************* GETMAIL BUTTON **************************/      
  myGLCD.setColor(255, 255, 255); //white
  myGLCD.fillRoundRect (10, last_y+2, 10+MAIL_FIELD_SIZE_X, last_y+MAIL_BANNER_SIZE_Y);             
  //myGLCD.drawBitmap( 10, last_y, 300, 36, mails_banner); 
  myGLCD.drawBitmap( 144, last_y+3, 32, 32, getmail); 
  myGLCD.setColor(0, 255, 0);  
  myGLCD.drawRoundRect (10, last_y+2, 10+MAIL_FIELD_SIZE_X, last_y+MAIL_BANNER_SIZE_Y);     
  myGLCD.drawBitmap( 260, last_y+3, 32, 32, icon_sendername[sendername_index]);
  myGLCD.setColor(0, 0, 255);
  myGLCD.drawRoundRect (260, last_y+3, 260+32, last_y+2+32);  
  set_field(button_nr , 
            144, 
            last_y+3, 
            144+32, 
            last_y+3+32, 
            NULL, mail);     
  getmail_mails_button_nr = button_nr;
 #ifdef DEBUG_BUTTONS 
  Serial.print(F("GetMail button nr in Mails page "));Serial.println(getmail_mails_button_nr);
 #endif           


  set_field(button_nr , 260, last_y+3, 260+32, last_y+3+32, 
            NULL, icon_sendername[sendername_index]);  
  change_user_mails_button_nr = button_nr;
 #ifdef DEBUG_BUTTONS 
  Serial.print(F("Change User button nr in Mails page "));Serial.println(change_user_mails_button_nr);
 #endif                     
  
  last_y += MAIL_BANNER_SIZE_Y + 5;
    
  /******************* MAILS FIELDS  **************************/  
  int field_index = 0;
  for( field_index = 0; field_index < MAX_MAIL_CNT ; field_index++ )
  {     
     myGLCD.setColor(0, 0, 255);
     myGLCD.fillRoundRect (START_X_MAILFIELD, last_y, START_X_MAILFIELD+MAIL_FIELD_SIZE_X, last_y+MAIL_FIELD_SIZE_Y);
     myGLCD.setColor(255, 255, 255);
     myGLCD.drawRoundRect (START_X_MAILFIELD, last_y, START_X_MAILFIELD+MAIL_FIELD_SIZE_X, last_y+MAIL_FIELD_SIZE_Y);
     String text_of_mail_1 = mails.mail_array[field_index].mail_text;
     String text_of_mail_2 = "";
     if( text_of_mail_1.length() > SIZE_OF_LINE )
     {       
       int end_of_line = mails.mail_array[field_index].mail_text.substring(0,SIZE_OF_LINE).lastIndexOf(' ');
       if( end_of_line < 0 )
         end_of_line = SIZE_OF_LINE;
       end_of_line = min(end_of_line, SIZE_OF_LINE);
       text_of_mail_1 = mails.mail_array[field_index].mail_text.substring(0,end_of_line);
       text_of_mail_2 = mails.mail_array[field_index].mail_text.substring(end_of_line+1, end_of_line+1+20);
      #ifdef DEBUG_BUTTONS 
       Serial.print(F("End Of Line "));Serial.println(end_of_line);
       Serial.print(F("Line1 "));Serial.println(text_of_mail_1);
       Serial.print(F("Line2 "));Serial.println(text_of_mail_2);
      #endif         
       
     }     
     String from_of_mail = mails.mail_array[field_index].from;
     int from_index = -1;
     boolean from_found = false;
     for( int k=0; k<MAILTO_CNT && !from_found; k++)
     {      
       if( mails.mail_array[field_index].from == key_mailto[k] )
       {
         from_index = k;
         from_found = true;
         myGLCD.drawBitmap( 268, last_y+2, 32, 32, icon_mailto[k]);
         myGLCD.setColor(255, 255, 255);
         myGLCD.drawRoundRect (268,last_y+2, 268+32, last_y+2+32);           
       }
     }
     
     if( mails.mail_array[field_index].att_file_name.length() > 2 )
     {
       myGLCD.drawBitmap( 233, last_y+2, 32, 32, arcoiris);
       myGLCD.setColor(255, 255, 255);
       myGLCD.drawRoundRect (233,last_y+2, 233+32, last_y+2+32);           
     } 
     
     if( text_of_mail_1.length() > 0 )
     {  
       //myGLCD.setFont(SmallFont);     
       myGLCD.setFont(Sinclair_S);     
       
       if( !from_found )
       {
         myGLCD.setColor(255, 0, 0);       
         myGLCD.print(from_of_mail, START_X_MAILFIELD +3 , last_y+1);
         myGLCD.setColor(255, 255, 255);
         myGLCD.print(text_of_mail_1, START_X_MAILFIELD +3 , last_y+13);
         myGLCD.print(text_of_mail_2, START_X_MAILFIELD +3 , last_y+23);                
       }
       else
       {
         myGLCD.setColor(255, 255, 255);
         myGLCD.print(text_of_mail_1, START_X_MAILFIELD +3 , last_y+7);
         myGLCD.print(text_of_mail_2, START_X_MAILFIELD +3 , last_y+20);                         
       }
       
       myGLCD.setFont(BigFont);
     }
     
    set_field(button_nr , 233, last_y+2, 233+32, last_y+2+32, 
            NULL, NULL, false, field_index, mails.mail_array[field_index].att_file_name);
     
    /******  MAILS FIELDS ******/  
    last_y += MAIL_FIELD_SIZE_Y+MAILS_SEPARATION;
    
  }
    
  
  /******************* OK BUTTON **************************/   
  myGLCD.drawBitmap( 20, last_y, 32, 32, ok); 
  myGLCD.drawRoundRect (20, last_y, 144 + 32, last_y + 32);
  
  set_field(button_nr , 20, last_y, 20+32, last_y+32, NULL, ok);  
  ok_mails_button_nr = button_nr;     
 #ifdef DEBUG_BUTTONS 
  Serial.print(F("Enter button nr in Mails page "));Serial.println(ok_mails_button_nr);
 #endif       
 
  fields_amount = button_nr;  
  DrawConnectionStatus();
}


void choose_mail( )
{
    if (myTouch.dataAvailable())
    {
      stlu();
      myTouch.read();
      x=myTouch.getX();
      y=myTouch.getY();
      
      for( int i=1; i<= fields_amount; i++ )
      {
        if( y>=fields[i].y1 && y<=fields[i].y2 && x>=fields[i].x1 && x<=fields[i].x2 )
        {
          waitForIt( fields[i].x1, fields[i].y1, fields[i].x2, fields[i].y2 );
          if( i == getmail_mails_button_nr )
          {
           //boolean mail_received = GetMails(-1);
           //if( mail_received == true )
           ReceiveMail( -1 );
           DrawImageSendBar(2, 2, IMAGE_SEND_BAR_CLEAN);
           DrawMailsPage();             
          }
          else if( i == ok_mails_button_nr )
          {
            waitForIt( fields[i].x1, fields[i].y1, fields[i].x2, fields[i].y2 );
            change_page( KEYBOARD_PAGE );          
          }
          else if( i == change_user_mails_button_nr )
          {
            waitForIt( fields[i].x1, fields[i].y1, fields[i].x2, fields[i].y2 );
            sendername_index++;
            if( sendername_index == SENDER_CNT )
              sendername_index = 0;
            myGLCD.drawBitmap( fields[i].x1, fields[i].y1,32,32, icon_sendername[sendername_index]) ;  
            //draw_one_button( sendername_button_nr, key_sendername[sendername_index], false );  
            myGLCD.setColor(255, 255, 255);
            myGLCD.drawRoundRect (fields[i].x1, fields[i].y1, fields[i].x2, fields[i].y2);     
            DrawMailsPage( );
          }
          else if( fields[i].mail_index >= 0 && fields[i].mail_index < MAX_MAIL_CNT )
          {
            int which_mail = fields[i].mail_index;
            if( mails.mail_array[which_mail].att_file_name.length() > 2 )
            {
              image_selected = which_mail;
              change_page( PICTURE_PAGE);
            }
          }
        }
      }
    }   
    else
    {
      if( otlu() )
        DrawMailsPage( );
    }
}


void DrawPicture( )
{  
  const int size_of_name = mails.mail_array[image_selected].att_file_name.length() + 2;
  char name[size_of_name];
  mails.mail_array[image_selected].att_file_name.toCharArray(name,size_of_name+1);
 #ifdef DEBUG_MAIL_LOGIC 
  Serial.print(F("Draw image "));Serial.print(name);Serial.print(F("."));  
 #endif 
 
  //char filepath[size_of_name+5];
  //sprintf(filepath, "/att/%s", name);
 #ifdef DEBUG_MAIL_LOGIC 
    Serial.println(F(" Searching file..."));  
 #endif
 
  if( !SD.exists(name) )
  {
   #ifdef DEBUG_MAIL_LOGIC 
    Serial.print(F("File "));Serial.print(name);Serial.println(F(" does not exist!"));
   #endif 
    //GetAttchmentFile( name, true);
  }
    
  read_image_file( name, ONLY_DRAW, 0,0,320,240, true );
}

void ReturnToMails( )
{
    if (myTouch.dataAvailable())
    {
      stlu();
      myTouch.read();
      x=myTouch.getX();
      y=myTouch.getY();  
      image_selected = -1;
      change_page( MAILS_PAGE );
    }
}

void drawColorMarkerAndBrushSize(int col)
{
  myGLCD.setColor(VGA_BLACK);
  myGLCD.fillRect(25, 0, 31, 239);
  myGLCD.fillRect(myGLCD.getDisplayXSize()-31, 161, myGLCD.getDisplayXSize()-1, 191);
  myGLCD.setColor(VGA_WHITE);
  myGLCD.drawPixel(25, (col*30)+15);
  for (int i=1; i<7; i++)
    myGLCD.drawLine(25+i, ((col*30)+15)-i, 25+i, ((col*30)+15)+i);
  
  if (color==1)
    myGLCD.setColor(VGA_WHITE);
  else
    myGLCD.setColor(colorlist[col]);
  if (bsize==1)
    myGLCD.drawPixel(myGLCD.getDisplayXSize()-15, 177);
  else
    myGLCD.fillCircle(myGLCD.getDisplayXSize()-15, 177, bsize);
    
  myGLCD.setColor(colorlist[col]);
}

void DrawPaintArea()
{
  #ifdef DEBUG_PAINT_APP    
   Serial.println(F("Painting now :- "));
  #endif   
  image_to_send[0] = '\0';
  last_used_color = -1;
  myGLCD.clrScr();
  myTouch.setPrecision(PREC_HI);  
  myGLCD.setColor(VGA_WHITE);
  myGLCD.drawLine(32,0,32,myGLCD.getDisplayYSize()-1);
  myGLCD.drawLine(myGLCD.getDisplayXSize()-32,0,myGLCD.getDisplayXSize()-32,myGLCD.getDisplayYSize()-1);
  myGLCD.print("C", myGLCD.getDisplayXSize()-24, 8);
  myGLCD.print("L", myGLCD.getDisplayXSize()-24, 24);
  myGLCD.print("E", myGLCD.getDisplayXSize()-24, 40);
  myGLCD.print("A", myGLCD.getDisplayXSize()-24, 56);
  myGLCD.print("R", myGLCD.getDisplayXSize()-24, 72);
  myGLCD.print("+", myGLCD.getDisplayXSize()-24, 136);
  myGLCD.print("-", myGLCD.getDisplayXSize()-24, 200);
  myGLCD.fillRect(myGLCD.getDisplayXSize()-32,96,myGLCD.getDisplayXSize()-1,128);
  myGLCD.drawLine(myGLCD.getDisplayXSize()-32,160,myGLCD.getDisplayXSize()-1,160);
  myGLCD.drawLine(myGLCD.getDisplayXSize()-32,192,myGLCD.getDisplayXSize()-1,192);
  myGLCD.drawLine(myGLCD.getDisplayXSize()-32,224,myGLCD.getDisplayXSize()-1,224);
  for (int i=0; i<8; i++)
  {
    myGLCD.setColor(colorlist[i]);
    myGLCD.fillRect(0, (i*30), 24, (((i+1)*30)-1));
  }
  drawColorMarkerAndBrushSize(color);  

}

void lets_paint()
{
  long x, y;
  
  while (myTouch.dataAvailable() == true)
  {
    stlu();
    myTouch.read();
    x = myTouch.getX();
    y = myTouch.getY();
    if ((x!=-1) and (y!=-1))
    {
      if (x>(31+bsize) and (x<myGLCD.getDisplayXSize()-(31+bsize)))
      {
       #ifdef DEBUG_PAINT_APP
        //Serial.println("BUTTON 1");
       #endif 
        if (bsize==1)
          myGLCD.drawPixel(x, y);
        else
          myGLCD.fillCircle(x, y, bsize);
        save_xy( x, y, bsize, color);  
      }
      else
      {
        if (x<(30+bsize))
        {
          if (y<240)
          {
       #ifdef DEBUG_PAINT_APP
        Serial.println(F("BUTTON 2"));
       #endif             
            color = y / 30;
            drawColorMarkerAndBrushSize(color);
            while (myTouch.dataAvailable()) {};
            delay(50);
         }
        }
        else
        {
          if (y<96)
          {
            close_image( true );
            myGLCD.setColor(VGA_BLACK);
            myGLCD.fillRect(33, 0, myGLCD.getDisplayXSize()-33, myGLCD.getDisplayYSize()-1);
            myGLCD.setColor(colorlist[color]);
          }
          if ((y>96) and (y<128))
          {
            #ifdef DEBUG_PAINT_APP
             Serial.println(F("Change page"));
            #endif             
            close_image( false );
            change_page( KEYBOARD_PAGE );
            delay(200);
          }
          if ((y>128) and (y<160))
          {
            if (bsize<7)
            {
       #ifdef DEBUG_PAINT_APP
        Serial.println(F("BUTTON 3"));
       #endif                           
              bsize++;
              drawColorMarkerAndBrushSize(color);
              while (myTouch.dataAvailable()) {};
              delay(50);
            }
          }
          if ((y>160) and (y<192))
          {
       #ifdef DEBUG_PAINT_APP
        Serial.println(F("BUTTON 4"));
       #endif                         
              bsize=4;
              drawColorMarkerAndBrushSize(color);
              while (myTouch.dataAvailable()) {};
              delay(50);
          }
          if ((y>192) and (y<224))
          {
            if (bsize>1)
            {
       #ifdef DEBUG_PAINT_APP
        Serial.println(F("BUTTON 5"));
       #endif                           
              bsize--;
              drawColorMarkerAndBrushSize(color);
              while (myTouch.dataAvailable()) {};
              delay(50);
            }
          }
        }
      }
    }  
  }
}

File root;
int pic_page_index = 0;
int last_pic_page_drawn = 0;

void printDirectory(File dir, String pictures[], bool& more_pics, int& pic_cnt) 
//void printDirectory(String pictures[], bool& more_pics, int& pic_cnt) 
{
  dir.rewindDirectory();
  bool stop_search = false;
  //int pic_cnt = 0;
  int found_pics = 0;
  char name_of_entry[40];
  name_of_entry[0] = '0';
  int size_of_entry = 10; //more than 0, we remove only images with a size of 0
   while(!stop_search) 
   {
     File entry =  dir.openNextFile();
     if (! entry) 
     {
       // no more files
       //Serial.println("**nomorefiles**");       
       break;
     }
     name_of_entry[0] = '0';
     size_of_entry = 10;
     if (entry.isDirectory() == false) 
     {
       if( entry.size() > 1 && 
           strstr( entry.name(),"IMAGE" ) != NULL && strstr( entry.name(),".TXT" ) != NULL )
       { 
         size_of_entry = entry.size();
         if( found_pics >= pic_page_index*MAX_PICS )
         {
           if( pic_cnt < MAX_PICS )
           {
            #ifdef  DEBUG_BROWSER
             Serial.print(F("Saving File "));Serial.print(entry.name());   
             Serial.print(F(" Size -> "));Serial.println(size_of_entry);      
            #endif                 
             pictures[pic_cnt++] = entry.name();
           }
           else
           {
             more_pics = true;
             //stop_search = true;
           }           
         #ifdef  DEBUG_BROWSER_2
           Serial.print(F("    Found Pics -> "));Serial.println(found_pics);        
         #endif             
       }
       found_pics++;         
       strcpy(name_of_entry, entry.name());
      #ifdef  DEBUG_BROWSER_2
       Serial.print(F("Size of image ")); Serial.print(name_of_entry); 
       Serial.println(F(" -> "));Serial.println(size_of_entry);        
      #endif            
      }
    }    
    entry.close();
//    if( size_of_entry < 1 )
  //    SD.remove(name_of_entry);
  }
}

void DrawBrowser(  )
{
  myGLCD.clrScr();
  myGLCD.setColor(0, 0, 0);  
  myGLCD.fillRect(0, 0, 319, 239);   
  myTouch.setPrecision(PREC_HI);  
  myGLCD.setColor(VGA_BLACK);

#ifdef DEBUG_BROWSER 
  Serial.println(F("\n********************************\nDrawing Browser Page\n********************************"));
  Serial.print(F("Pic Page Index -> "));  Serial.println(pic_page_index);
#endif     
  int button_nr = -1;
  int row_index = 0;
  int row_elem_index = 0;
  int row_elem = 3;
  int row_cnt = 3;
  int total_pics = MAX_PICS;
  int last_y = 0;
  int pics_y_sep = 3;
  last_y = 0;
  bool more_pics = false;
  
  int pic_cnt = 0;
  int found_pics = 0;  
  String pictures[MAX_PICS]= {"","","","","","","","",""};
  root = SD.open("/");
  printDirectory(root, pictures, more_pics, found_pics);  
 #ifdef  DEBUG_BROWSER
  Serial.print(F("More file -> "));Serial.println(more_pics);        
  Serial.print(F("Found Pics -> "));Serial.println(found_pics);        
 #endif   
  
  
  int drawn_pics = 0;
  bool stop_drawing = false;
  /*
  for( row_index = 0; row_index < row_cnt ; row_index++ )
  {
    for( row_elem_index = 0; row_elem_index < row_elem ; row_elem_index++ )
    {
     #ifdef  DEBUG_BROWSER
      Serial.print(F("Stop Drawing -> "));Serial.println(stop_drawing);              
     #endif
     
      if( button_nr+1 == MAX_PICS || button_nr+1 > found_pics || stop_drawing )
      {
       #ifdef DEBUG_BROWSER 
        Serial.println(F("No more Pics for browser"));
       #endif 
        more_pics = false;
        break;
      }        
      myGLCD.setColor(255, 255, 255);
      myGLCD.drawRoundRect (key_separation+(row_elem_index*pic_size_x), 
                            row_index*pic_size_y + pics_y_sep, 
                            pic_size_x+(row_elem_index*pic_size_x), 
                            row_index*pic_size_y + pics_y_sep + pic_size_y);
                         
      const int size_of_image = pictures[drawn_pics].length();
      char pic_to_draw[size_of_image+1];
      pictures[drawn_pics].toCharArray(pic_to_draw, size_of_image+1);
     #ifdef  DEBUG_BROWSER
      Serial.print(F("File Button "));Serial.print(drawn_pics);
      Serial.print(F(" "));Serial.println(pic_to_draw);        
     #endif             
      stop_drawing = !read_image_file( pic_to_draw, ONLY_DRAW, 
                                      fields[button_nr].x1,
                                      fields[button_nr].y1,
                                      fields[button_nr].x2,
                                      fields[button_nr].y2,
                                      false);
 
      set_field(button_nr , 
               key_separation+(row_elem_index*pic_size_x), 
               row_index*pic_size_y + pics_y_sep, 
               pic_size_x+(row_elem_index*pic_size_x), 
               row_index*pic_size_y + pics_y_sep + pic_size_y, 
               NULL, NULL, false, -1, pictures[drawn_pics]);         
      drawn_pics++;         
    }
    last_y = row_index*pic_size_y + pics_y_sep + pic_size_y;
  }*/
  for( row_index = 0; row_index < row_cnt ; row_index++ )
  {
    for( row_elem_index = 0; row_elem_index < row_elem ; row_elem_index++ )
    {
     #ifdef  DEBUG_BROWSER
      Serial.print(F("Stop Drawing -> "));Serial.println(stop_drawing);              
     #endif
     
      button_nr++;
      if( button_nr == MAX_PICS || button_nr > found_pics || stop_drawing )
      {
       #ifdef DEBUG_BROWSER 
        Serial.println(F("No more Pics for browser"));
       #endif 
        more_pics = false;
        break;
      }        
      myGLCD.setColor(255, 255, 255);
      myGLCD.drawRoundRect (key_separation+(row_elem_index*pic_size_x), 
                            row_index*pic_size_y + pics_y_sep, 
                            pic_size_x+(row_elem_index*pic_size_x), 
                            row_index*pic_size_y + pics_y_sep + pic_size_y);
      if( fields[button_nr].set_done == false )
      {
        fields[button_nr].set_done = true;
        fields[button_nr].x1 = key_separation+(row_elem_index*pic_size_x);
        fields[button_nr].y1 = row_index*pic_size_y + pics_y_sep;
        fields[button_nr].x2 = pic_size_x+(row_elem_index*pic_size_x);
        fields[button_nr].y2 = row_index*pic_size_y + pics_y_sep + pic_size_y;
      }    
      const int size_of_image = pictures[drawn_pics].length();
      char pic_to_draw[size_of_image+1];
      pictures[drawn_pics].toCharArray(pic_to_draw, size_of_image+1);
     #ifdef  DEBUG_BROWSER
      Serial.print(F("File Button "));Serial.print(drawn_pics);
      Serial.print(F(" "));Serial.println(pic_to_draw);        
     #endif             
      stop_drawing = !read_image_file( pic_to_draw, ONLY_DRAW, 
                                      fields[button_nr].x1,
                                      fields[button_nr].y1,
                                      fields[button_nr].x2,
                                      fields[button_nr].y2,
                                      false);
      fields[button_nr].file_name = pictures[drawn_pics++];      
    }
    last_y = row_index*pic_size_y + pics_y_sep + pic_size_y;
  }  
  
  /******************* OK BUTTON **************************/   
  button_nr++;
  last_y = 140;
  myGLCD.drawBitmap( 280, last_y, 32, 32, ok); 
  myGLCD.drawRoundRect (280, last_y, 280 + 32, last_y + 32);
  
  set_field(button_nr , 280, last_y, 280+32,last_y+32, NULL, ok);    
    ok_browser_button_nr = button_nr;     
  #ifdef DEBUG_BUTTONS 
    Serial.print(F("Enter button nr in Browser page "));Serial.println(ok_mails_button_nr);
  #endif       
  last_y += pic_size_y+3;
  
  fields_amount = button_nr;      
  /******************* NEXT BUTTON **************************/   
  if( more_pics && !stop_drawing)
  {
    button_nr++;
    myGLCD.drawBitmap( 280, last_y, 32, 32, hand); 
    myGLCD.drawRoundRect (280, last_y, 280 + 32, last_y + 32);
    
    set_field(button_nr , 280, last_y, 280+32,last_y+32, NULL, hand);    
     next_browser_button_nr = button_nr;     
    #ifdef DEBUG_BUTTONS 
      Serial.print(F("Enter button nr in Browser page "));Serial.println(ok_mails_button_nr);
     #endif         
    fields_amount = button_nr;    
  }
  
  last_pic_page_drawn  =  pic_page_index;
}

void choose_pic( )
{
    if (myTouch.dataAvailable())
    {
      stlu();
      myTouch.read();
      x=myTouch.getX();
      y=myTouch.getY();
      
      for( int i=1; i<= fields_amount; i++ )
      {
        if( y>=fields[i].y1 && y<=fields[i].y2 && x>=fields[i].x1 && x<=fields[i].x2 )
        {
          waitForIt( fields[i].x1, fields[i].y1, fields[i].x2, fields[i].y2 );
          
          /*********************   OK   ***********************/
          if( i == ok_browser_button_nr )
          {
            waitForIt( fields[i].x1, fields[i].y1, fields[i].x2, fields[i].y2 );
            pic_page_index = 0;
            change_page( KEYBOARD_PAGE );          
          }
          /*********************  PICTURE  ***********************/          
          else if( fields[i].file_name.length()  > 0 )
          {
            //strcpy(image_to_send, fields[i].file_name);
            fields[i].file_name.toCharArray(image_to_send, fields[i].file_name.length()+1); 
           #ifdef DEBUG_BROWSER 
            Serial.print(F("Now Picture is "));Serial.println(image_to_send); 
           #endif            
            read_image_file( image_to_send, ONLY_DRAW, 0,0,320,240, true);
            while( !myTouch.dataAvailable() );
            DrawBrowser( );                          
          }
          /*********************   NEXT   ***********************/          
          if( i == next_browser_button_nr )
          {
            waitForIt( fields[i].x1, fields[i].y1, fields[i].x2, fields[i].y2 );
           #ifdef DEBUG_BROWSER 
            Serial.println(F("Next Page"));
           #endif                  
            pic_page_index++;
            DrawBrowser( );          
          }          
        }
      }
    }   
    else
    {
      if( otlu() )
      if( newmail == true && !newmail_drawn)
      {
        myGLCD.setColor(0, 255, 255);
        myGLCD.print("M", RIGHT, 226);
        newmail_drawn = true;
      }             
    }    
}





void change_page( int page_nr )
{
  if( page_nr < KEYBOARD_PAGE || page_nr > BROWSER_PAGE )
    return;

  last_drawn_status = !connection_established;
  newmail_drawn = false;
  
  myGLCD.setColor(0, 0, 0);  
  myGLCD.fillRect(0, 0, 319, 239); 
    
  iPAGE = page_nr;    
  init_fields_pos( );
  switch( iPAGE )
  {
    case PAINT_PAGE: DrawPaintArea();
                     if( newmail == true )
                     {
                        myGLCD.setColor(0, 255, 255);
                        myGLCD.print("M", RIGHT, 226);
                     }         
                     break;
    case KEYBOARD_PAGE: DrawButtons(  ); 
                        draw_saved_text();  
                        DrawConnectionStatus( true );
                        if( newmail == true )
                        {
                          myGLCD.setColor(0, 255, 255);
                          myGLCD.print("M", RIGHT, 226);
                        }     
                        break;
    case MAILS_PAGE: DrawMailsPage();    
                     DrawConnectionStatus( true );
                     break;
    case PICTURE_PAGE: DrawPicture();
                     break;          
    case BROWSER_PAGE: DrawBrowser();
                       break;    
    default: break;
  }
  
}

void init_wifi_modul()
{  
  echoCommand("AT+RST", "ready", HALT);    // Reset & test if the module is ready  
  Serial.print(F("Module."));
  echoCommand("AT+GMR", "OK", CONTINUE);   // Retrieves the firmware ID (version number) of the module. 
  Serial.print(F("."));  
  echoCommand("AT+CWMODE?","OK", CONTINUE);// Get module access mode. 
  Serial.print(F("."));    
  echoCommand("AT+CWMODE=3", "", HALT);    // Station mode
  Serial.print(F("."));    
  echoCommand("AT+CIPMUX=1", "", HALT);    // Allow multiple connections (we'll only use the first).
  Serial.print(F(".")); 
  echoCommand("AT+CIPSTO=120", "", HALT);
  Serial.println(F(".ready!"));  
  Serial3.flush();
}

void reinit_wifi()
{
  CloseConn();
 #ifdef DEBUG_MAIL_LOGIC    
  Serial.println(F("Reinitialization of WIFI"));
 #endif  
  echoCommand("AT+RST", "ready", HALT);
  echoCommand("AT+CWMODE=3", "", HALT);
  echoCommand("AT+CIPMUX=1", "", HALT);
  connectWiFi(where_connected);
}


void setup()
{
  Serial.begin(115200);
  Wire.begin();
// Initial setup
  myGLCD.InitLCD();
  myGLCD.clrScr();
//  file.initFAT();

  myTouch.InitTouch();
  myTouch.setPrecision(PREC_MEDIUM);

  myGLCD.setFont(BigFont);
  //myGLCD.setFont(various_symbols);
  myGLCD.setBackColor(0, 0, 255);
  
  word res;
  //myGLCD.drawBitmap( 0, 0, 320, 240, ninosk); 
  /*
  res=myFiles.loadBitmap(0, 0, 320, 240, "/fotos/ninos.raw");
  if (res==0x10)
   {
      myGLCD.print("File not found...", 0, 0);  
      myGLCD.print("/Fotos/ninos.raw", 0, 14);
   }      
   delay(5000);
   */
  
  /*
  init_fields_pos( );
  init_fields_pos( );  
  ´*/
  // //iPAGE = KEYBOARD_PAGE;  
  // //DrawButtons();    
  
  //iPAGE = MAILS_PAGE;  
  
  myGLCD.setColor(255, 0, 0);
  myGLCD.print("espera", RIGHT, 224);  

  //myGLCD.setBackColor(0, 255, 0);
  
  if (!SD.begin(53)) 
  {
    Serial.println(F("SD Card initialization failed!"));
    return;
  }
  
  root = SD.open("/");
  
  myGLCD.setColor(0, 0, 0);  
  myGLCD.fillRect(180, 224, 319, 239);
  myGLCD.print("SD Karte", RIGHT, 224);  
  
  Serial.println(F("SD Card Initialization.........DONE"));  
  for( int i=0; i<SENDER_CNT; i++)
  {
    char _name[12];
    sprintf(_name, "inbox%d.txt", i );
    _name[11]='\0';
    if( SD.exists(_name) )
    {
      int size_of_inbox=0;
      File tmpfile = SD.open(_name);
      if( tmpfile )
      {
        size_of_inbox = tmpfile.size();
       #ifdef DEBUG_MAIL_LOGIC    
        Serial.print(F("INBOX for "));Serial.print(key_sendername[i]); 
        Serial.print(F(" found. Size is "));Serial.println(size_of_inbox);      
       #endif 
       tmpfile.close();
       /*
       if( size_of_inbox > 5000 )
       {
        #ifdef DEBUG_MAIL_LOGIC    
         Serial.print(F("Too big!. Removing "));Serial.println(_name); 
        #endif         
         SD.remove( _name );
       }*/
     }
    }
  }
  SD.mkdir("att");  //Directory for attachments
  
  
  myGLCD.setColor(0, 0, 0);  
  myGLCD.fillRect(150, 224, 319, 239);
  myGLCD.print("WIFI", RIGHT, 224);     
  /*********************** ESP8266 Connection    *****************************************************/
  Serial3.begin(115200);        // Communication with ESP8266 via 5V/3.3V level shifter
  //Serial3.begin(9600);        // Communication with ESP8266 via 5V/3.3V level shifter
  
  Serial3.setTimeout(TIMEOUT);
  Serial.print(F("Connecting ESP8266 -> "));  
  delay(2000);

  init_wifi_modul();
  
  //connect to the wifi
  int router = WHERE_CASA;
  for(int i=0;i<8;i++)
  {
    Serial.print(F("Try ")); Serial.println(( router == WHERE_CASA )?"FrtizBox":"HotSpot"); 
    if(connectWiFi(router))
    {      
      connection_established = true;
      Serial.print(F("Connected with ")); Serial.println(( router == WHERE_CASA )?"FrtizBox":"HotSpot"); 
      break;
    }
    else
    {
      if( router == WHERE_CASA )
        router = WHERE_HOT;
      else  
        router = WHERE_CASA;             
    }        
  }
  if( where_connected == WHERE_HOT )
  {
    Serial.print(F("Connetion with Handy. Timeout now 6000."));
    echoCommand("AT+CIPSTO=6000", "", HALT);
  }
  
  if (!connection_established) errorHalt("Connection failed");    
  delay(5000);

  echoCommand("AT+CWSAP=?", "OK", CONTINUE); // Test connection
  echoCommand("AT+CIFSR", "OK", HALT);         // Echo IP address. (Firmware bug - should return "OK".)    
  echoCommand("AT+GMR", "OK", CONTINUE); // Test connection
  myGLCD.setColor(0, 0, 0);  
  myGLCD.fillRect(150, 224, 319, 239);
  myGLCD.print("espera", RIGHT, 224);    
  
  CloseConn();  
  
  iPAGE = KEYBOARD_PAGE;  
  DrawButtons();    
  myGLCD.print("espera", RIGHT, 224);      
  
  //myGLCD.setColor(255, 0, 0);
  //myGLCD.print("espera", RIGHT, 224);    
  
  myGLCD.setColor(0, 0, 0);  
  myGLCD.fillRect(180, 224, 319, 239); 
  myGLCD.print("OK", RIGHT, 224);
  delay(1000);
  myGLCD.setColor(0, 0, 0);  
  myGLCD.fillRect(180, 224, 319, 239);   
  
  
  setSyncProvider(RTC.get);   // the function to get the time from the RTC
  if(timeStatus()!= timeSet) 
     Serial.println("Unable to sync with the RTC");
  else
     Serial.println("RTC has set the system time");      
     
  //setTime(hour(),minute(),second(),month(),day(),year()-2000);    
  Serial.print(hour());
  printDigits(minute());
  printDigits(second());
  Serial.print(" ");
  Serial.print(day());
  Serial.print(" ");
  Serial.print(month());
  Serial.print(" ");
  Serial.print(year()); 
  Serial.println(); 
  Serial.println("\nREADY");
//  read_inbox_for_all( );
//  GetMails( -1 ); 
//  Alarm.timerRepeat(150, time_to_check_mails); 
  tlu = second();  

}


void printDigits(int digits){
  // utility function for digital clock display: prints preceding colon and leading 0
  Serial.print(":");
  if(digits < 10)
    Serial.print('0');
  Serial.print(digits);
}

#define OTLU 50  //Old Time last use
void stlu(){  tlu = second(); }
bool otlu( )
{
  bool is_time= false;
  if( second() < tlu )   
    is_time = ( (60-tlu)+second() > OTLU );
  else  
    is_time = ( second() - tlu > OTLU );
    
  if( is_time )
  {
    tlu = second();
    ReceiveMail( -1 ); 
    if( newmail )
     newmail_drawn = false;   
    DrawImageSendBar(2, 2, IMAGE_SEND_BAR_CLEAN);
  }  
  return is_time;  
}


void loop()
{ 
  //char saved_filename[200];
  //GetAttchmentFile( "image8.txt", saved_filename, true);
  //sread_image_file("/att/image62.txt", DRAW_PRINT);
  //delay(3000);
  //DecodeMails( 0 );#
  
  /////////////
  while( iPAGE == KEYBOARD_PAGE )
  {
    what_do_you_want();  
  }
  while( iPAGE == PAINT_PAGE )
  {
    lets_paint();  
  }
  while( iPAGE == MAILS_PAGE )
  {
    choose_mail();
  }  
  while( iPAGE == PICTURE_PAGE )
  {
    ReturnToMails( );
  }
  while( iPAGE == CLOCK_PAGE )
  {
  }
  while( iPAGE == BROWSER_PAGE )
  {
    choose_pic( );
  }
}
  
 
 


/***********************************************  MAILS ***********************************************/  

void CloseConn()
{
 #ifdef DEBUG_MAIL_LOGIC 
  Serial.println(F("\n\nClosing any connection.............................NOW "));
 #endif  
  echoCommand("AT+CIPCLOSE", "", CONTINUE);
}


/****************************************************************************/
/*********************** SEND TEXT MAIL    **********************************/
/****************************************************************************/
bool send_to_php_MAIL( boolean force_connect )
{
 #ifdef DEBUG_MAIL_LOGIC
      Serial.print(F("Sending eMail to "));Serial.println(key_mailto[mailto_index]);
 #endif

 if( last_wifi_opeartion == LAST_RECEIVE )
   reinit_wifi();

 DrawImageSendBar(0, 2, IMAGE_SEND_BAR_OK);
 
 if( force_connect == true )
 {
 #ifdef DEBUG_MAIL_LOGIC
   Serial.print(F("Connecting in send_to_php_MAIL()... "));
 #endif    
   // Establish TCP connection
   String cmd = "AT+CIPSTART=0,\"TCP\",\""; cmd += DEST_HOST; cmd += "\",80";
   if (!echoCommand(cmd, "OK", CONTINUE)) 
   {
 #ifdef DEBUG_MAIL_LOGIC
     Serial.print(F("No TCP connection "));
 #endif    
     DrawImageSendBar(1, 1, IMAGE_SEND_BAR_ERROR); 
     return false;
   }
   
   delay(2000);
   last_wifi_opeartion = LAST_SEND;
   
   // Get connection status 
   if (!echoCommand("AT+CIPSTATUS", "OK", CONTINUE)) 
   {
 #ifdef DEBUG_MAIL_LOGIC
     Serial.print(F("TCP connection status failed."));
 #endif      
     DrawImageSendBar(1, 1, IMAGE_SEND_BAR_ERROR); 
     return false;
   }
   
 #ifdef DEBUG_MAIL_LOGIC
   Serial.print(F("Connected in send_to_php_MAIL()"));
 #endif       
 }

  String cmd;
   // Build HTTP request.
  String mail_body = give_me_text();
  
  DrawImageSendBar(1, 1, IMAGE_SEND_BAR_OK);
  
 #ifdef DEBUG_MAIL_LOGIC_2
  Serial.println(F("MAIL BODY"));
  Serial.println(mail_body);
 #endif  
  cmd = "GET /scripts/Radioteleskop/GetMails.php/?SendMailFrom=";
  cmd += String(key_sendername[sendername_index]);
  cmd += "&SendMailTo=";
  cmd += String(key_mailto[mailto_index]);
  cmd += "&MailBody=";
  if( mail_body.length() < 1 )
    cmd += "Nada";
  else  
    cmd += mail_body;
  if( strlen(image_to_send) >= 5 ) 
  {
    cmd += "&IN=";
    cmd += image_to_send;
  }
  cmd += " HTTP/1.1\r\nHost: "; cmd += DEST_HOST; cmd += ":80\r\n\r\n";
 #ifdef DEBUG_MAIL_LOGIC_2
  Serial.println(F("COMMAND:"));
  Serial.println(cmd);
 #endif    
  if (!echoCommand("AT+CIPSEND=0,"+String(cmd.length()), ">", CONTINUE))
  {    
    echoCommand("AT+CIPCLOSE", "", CONTINUE);
    Serial.println(F("Connection timeout in send_mail()."));
    return false;
  } 
  // Send the raw HTTP request
  echoCommand(cmd, "OK", CONTINUE);  // GET 
  Serial3.flush();
  Serial.println(F("MAIL SENT"));
  return true;
}




/****************************************************************************/
/***********************    SEND PICTURE PACKET   ***************************/
/****************************************************************************/
boolean send_file( int packet, String& image_str, boolean force_connect, boolean end_of_file )
{
 #ifdef DEBUG_MAIL_LOGIC
  Serial.print(F("Uploading image packet "));Serial.println(packet);
 #endif
 
 if( force_connect == true )
 {
 #ifdef DEBUG_MAIL_LOGIC
  Serial.print(F("Connecting in send_file()... "));
 #endif   
  // Establish TCP connection
  String cmd = "AT+CIPSTART=0,\"TCP\",\""; cmd += DEST_HOST; cmd += "\",80";
  if (!echoCommand(cmd, "OK", CONTINUE)) 
  {
 #ifdef DEBUG_MAIL_LOGIC
     Serial.print(F("No TCP connection in send_file()"));
 #endif       
    connection_established = false;
    return false;
  }
    
  delay(2000);  
  
  // Get connection status 
  if (!echoCommand("AT+CIPSTATUS", "OK", CONTINUE)) 
  {
 #ifdef DEBUG_MAIL_LOGIC
     Serial.print(F("TCP connection status failed in send_file()"));
 #endif       
    connection_established = false;
    return false;   
  }
  
 #ifdef DEBUG_MAIL_LOGIC
    Serial.println(F("OK"));
 #endif       
 }
  
  // Establish TCP connection
  String cmd;
  delay(800);   
  
  cmd = "GET /scripts/Radioteleskop/GetMails.php/?";
  if( packet == 0 )
    cmd += "SI=1";
  cmd += "&IN=";
  cmd += String(image_to_send);
  cmd += "&I=";        
  cmd += image_str;
  if( end_of_file == true )  
    cmd += "&EI=1";    
  cmd += " HTTP/1.1\r\nHost: "; cmd += DEST_HOST; cmd += ":80\r\n\r\n";
  if (!echoCommand("AT+CIPSEND=0,"+String(cmd.length()), ">", CONTINUE))
  {    
    echoCommand("AT+CIPCLOSE", "", CONTINUE);
    Serial.println(F("Connection timeout in send_file()."));
    return false;
  } 
  // Send the raw HTTP request
  echoCommand(cmd, "OK", CONTINUE);  // GET    
  Serial3.flush();
  return true;
}


/****************************************************************************/
/***********************        SEND PICTURE      ***************************/
/****************************************************************************/
#define MAX_PACKET_LEN 400
#define TRY_FOR_1_PACKET 4
boolean send_to_php_IMAGE()
{
  if( strlen(image_to_send) < 5 )
  {
    image_to_send[0] = '\0';
    return true;
  }
 
  DrawImageSendBar(0, 1, IMAGE_SEND_BAR_OK); 
  if( last_wifi_opeartion == LAST_RECEIVE )
   reinit_wifi(); 
      
  File img = SD.open( image_to_send );    
  if( img )
  {    
   #ifdef DEBUG_MAIL_LOGIC    
    Serial.print(F("Sending Attachment\n"));
    Serial.print(F("Image to send: "));Serial.println(image_to_send);    
    Serial.print(F("Image size: "));Serial.println(img.size());        
   #endif  
    int packet_cnt = (img.size() / MAX_PACKET_LEN ) + 1;
    String cmd_img;
    boolean file_end = false;
    int packet_num = 0;
    boolean set_new_connect = true;
    boolean read_more = true;
    int last_sent_packet = -1;
    int try_cnt = TRY_FOR_1_PACKET;
    while( img.available() )
    {
      int i=0;
      cmd_img = "";
      while( read_more && img.position()< img.size() && i++ < MAX_PACKET_LEN)
      {
        cmd_img += (char)img.read();
      }  
     #ifdef DEBUG_MAIL_LOGIC    
      //Serial.print(F("Image packet read : "));Serial.println(cmd_img);
      Serial.print(F("Connection Status : "));Serial.println(!set_new_connect);      
     #endif           

      if( img.position()>= img.size())
      {
      #ifdef DEBUG_MAIL_LOGIC
        Serial.println(F("Last Packet"));
      #endif                    
        file_end = true;        
      }     
     
      set_new_connect = !send_file( packet_num++, cmd_img, set_new_connect, file_end);
      read_more = !set_new_connect;
      if( !read_more )
        packet_num--;
      else
        DrawImageSendBar(packet_num, packet_cnt, IMAGE_SEND_BAR_OK);   
        
      if( last_sent_packet != packet_num )
      {
        last_sent_packet = packet_num;
        try_cnt = TRY_FOR_1_PACKET;
        last_wifi_opeartion = LAST_SEND;
      }
      else  
      {
        try_cnt--;
        reinit_wifi();
        DrawImageSendBar(packet_num, packet_cnt, IMAGE_SEND_BAR_ERROR);
      }
      if( try_cnt == 0 )
      {
        img.close();
        SD.remove(image_to_send);
       #ifdef DEBUG_MAIL_LOGIC    
        Serial.println(F("No luck by sending image. Abort. "));
       #endif           
        return false;
      }
        
     #ifdef DEBUG_MAIL_LOGIC    
      Serial.print(F("Connection Status: "));Serial.println(!set_new_connect);Serial.print(F("\n"));      
     #endif                     
      
    }
    
    img.close();    
   #ifdef DEBUG_MAIL_LOGIC
    Serial.println(F("Image sent"));
   #endif            
    
    myGLCD.setColor(0, 0, 0);  
    myGLCD.fillRect(0, 219, 319, 239);    
    return set_new_connect;
  }
}

/****************************************************************************/
/*******    DRAW PACKET SENDING STATUS BY SEND PICTURE   ********************/
/****************************************************************************/
void DrawImageSendBar( int packet, int total_packets, int type)
{   
  int start_x = icon_separation+(3*icon_size);
  int end_x = icon_separation+(6*icon_size)+32;
  
  if( type == IMAGE_SEND_BAR_CLEAN )
  {
    myGLCD.setColor(0, 0, 0);  
    myGLCD.fillRect(130, 219, 319, 231);   
    return;
  }
    
  myGLCD.setColor(0, 0, 255);  
  myGLCD.drawRect ( start_x , 220, end_x ,230); 
  int x_pro_packet = (end_x - start_x) / total_packets;
  if( type == IMAGE_SEND_BAR_ERROR )
    myGLCD.setColor(255, 0, 0);
  else  
    myGLCD.setColor(0, 255, 0);
  int x_end_packet = min(320, ( start_x + (x_pro_packet*packet)) );
  myGLCD.fillRoundRect ( start_x , 220, x_end_packet, 230);   
 #ifdef DEBUG_MAIL_LOGIC_    
  Serial.print(F("Draw bar: "));Serial.print(start_x);Serial.print(F("-")); Serial.println(x_end_packet);     
 #endif      
    
  if( type == IMAGE_SEND_BAR_ERROR )
    delay(500);
}

/****************************************************************************/
/***********************    GET BODY FOR MAIL     ***************************/
/****************************************************************************/
String give_me_text()
{
  String body;
  int i = 0;
  for( i=0; i< MSG_ROW_LEN && i<strlen(stLast3); i++)
  {
    if( stLast3[i] == ' ' )
      body += "%20";
    else
      body += stLast3[i];
  } 
  if( i>1 )
    body += "%20";
  for( i=0; i< MSG_ROW_LEN && i<strlen(stLast2); i++)
  {
    if( stLast2[i] == ' ' )
      body += "%20";
    else
      body += stLast2[i];
  } 
  if( i>1 )
    body += "%20"; 
  for( i=0; i< MSG_ROW_LEN && i<strlen(stLast); i++)
  {
    if( stLast[i] == ' ' )
      body += "%20";
    else
      body += stLast[i];
  } 
  if( i>1 )
    body += "%20";
  for( i=0; i< MSG_ROW_LEN && i<strlen(stCurrent); i++)
  {
    if( stCurrent[i] == ' ' )
      body += "%20";
    else
      body += stCurrent[i];
  } 
  return body; 
}

boolean ReceiveMail( int person )
{
  boolean got_mail = false;
  last_check[person] = now();
  
 if( last_wifi_opeartion == LAST_SEND )
   reinit_wifi();
  
  
  DrawImageSendBar(1,2, IMAGE_SEND_BAR_OK);
  
  if ( SD.exists(MAILSFILE) )
    SD.remove( MAILSFILE );
    
  String who_ask="";
  int who_ask_index=0;
  if( person == -1 )  
  {
    who_ask = String(key_sendername[sendername_index]);
    who_ask_index = sendername_index;
  }
  else
  {
    who_ask = String(key_sendername[person]);
    who_ask_index = person;
  }  
    
 #ifdef DEBUG_MAIL_LOGIC 
  Serial.print(F("Receiving Mails for "));Serial.println(key_sendername[who_ask_index]); 
 #endif  
  
  myGLCD.setColor(255, 0, 0);
  myGLCD.print("M", RIGHT, 226);

  if (!echoCommand("AT+CIPMUX=1", "OK", CONTINUE)) 
  {
   #ifdef DEBUG_MAIL_LOGIC
    Serial.println(F("Multiple TCP connections not working in ReceiveMail()"));
   #endif 
    connection_established = false;
    DrawImageSendBar(2,2, IMAGE_SEND_BAR_ERROR);
    return false;       
  }
  String cmd = "AT+CIPSTART=0,\"TCP\",\""; cmd += DEST_HOST; cmd += "\",80";
  if (!echoCommand(cmd, "OK", CONTINUE)) 
  {
   #ifdef DEBUG_MAIL_LOGIC 
    Serial.println(F("TCP connection start failed in ReceiveMail()"));
   #endif 
    connection_established = false;
    DrawImageSendBar(2,2, IMAGE_SEND_BAR_ERROR);
    return false;
  }
  delay(2000);
  
  last_wifi_opeartion = LAST_RECEIVE;
  
  // Get connection status 
  if (!echoCommand("AT+CIPSTATUS", "OK", CONTINUE)) 
  {
   #ifdef DEBUG_MAIL_LOGIC 
    Serial.println(F("Connection Status failed in ReceiveMail()"));
   #endif 
    connection_established = false;
    return false;
  }

 #ifdef DEBUG_MAIL_LOGIC 
  Serial.println(F("TCP connection OK. Waiting now for mail..."));
 #endif 
  DrawImageSendBar(2,2, IMAGE_SEND_BAR_OK);
  // Build HTTP request.
  //We update the current values comming from Gy-80 and state if moving
  cmd = "";
  cmd = "GET /scripts/Radioteleskop/GetMails.php/?";
  cmd += "MailName=";
  cmd += String(key_sendername[who_ask_index]);
  cmd += " HTTP/1.0\r\nHost: "; cmd += DEST_HOST; cmd += ":80\r\n\r\n";  
  //Serial.println( cmd);
  
  if (!echoCommand("AT+CIPSEND=0,"+String(cmd.length()), ">", CONTINUE))
  {
    echoCommand("AT+CIPCLOSE", "", CONTINUE);
    Serial.println(F("Connection timeout in ReceiveMail()."));
    connection_established = false;
    return got_mail;
  }  
  // Send the raw HTTP request
  echoCommand(cmd, "OK", CONTINUE);  // GET
   
  boolean getting_mail = true;
  int liUnlink = -1;
  
  File mail_file = SD.open(MAILSFILE, FILE_WRITE);
 

  String newword="";
//  int size_of_pt_mess = 0;
  boolean receive_ok = false;
  if( getting_mail )
  {
    boolean print_done = false;
    boolean read_done= false;
    #ifdef DEBUG  
      Serial.println(F("Setting interrup to start listening....\n\n\n"));    
    #endif
    set_interrupt(TIME_LONG);
    boolean start_loggin = false;
    char end_of_message[12];
    end_of_message[0] = '\0';
    int index_eom = 0;    
    char received_char = ' ';
    while(!b_stop_loop)
    {    
      if(Serial3.available())
      {
        if( received_char != 'F' && 
            received_char != 'i' && 
            received_char != 'n' && 
            received_char != 'e' && 
            received_char != 'h' &&
            received_char != 's' && 
            received_char != 'd' && 
            received_char != 'l' &&            
            received_char != 'k' &&
            received_char != 'U' &&            
            received_char != '#' )
              newword = "";   //Unlink or #Finnished
              
        received_char = Serial3.read();
        /*
        myGLCD.setColor(255, 0, 0);
        myGLCD.print((String)received_char, 160, 226);
        */
        newword += received_char;
        if( received_char == '_' )
          start_loggin = true;

      //#ifdef DEBUG      
        Serial.write(received_char);
      //#endif        
        if( start_loggin == true )        
          mail_file.print((char)received_char);

        //if( start_loggin == true )
          //set_interrupt(TIME_LONG);
          
        if( newword.lastIndexOf("nlink") > -1 )
        {
            b_stop_loop = true;
            //receive_ok = false;
            receive_ok = true;
            Serial.println(F(" -> Unlink. Receive ERROR."));            
        }  
        
        if ( /*start_loggin &&*/ received_char == '#' )
        {
          Serial.print(F("Testing EOM -> "));
          Serial.print(newword);
          if ( newword.lastIndexOf("Finnished") > -1 )
          {
            b_stop_loop = true;            
            receive_ok = true;
            Serial.println(F(" -> EOM found!"));
          }
          else
            Serial.println("");
        }
      }    
    } 
    #ifdef DEBUG
      Serial.println(F("\nINTERRUPT 2\n\n\n"));  
    #endif 
  }
  
  //noInterrupts();
  //CloseConn();
 #ifdef DEBUG_MAIL_LOGIC
  Serial.print(F("Mail File Size after Download "));Serial.println(mail_file.size());
 #endif    

  int mail_size = mail_file.size(); 
  mail_file.close();
  delay(800);

  if( ! receive_ok  )
  {    
    Serial.println(F("No END-OF-MESSAGE found. No Mail."));
    myGLCD.setColor(0, 0, 0);  
    myGLCD.fillRect(180, 224, 319, 239);          
    return false;
  }      
  
  if( mail_size > 0 )
  {
#ifdef DEBUG_MAIL_LOGIC
    Serial.println(F("Reading Mails after download."));
#endif
    DecodeMails(who_ask_index );
  }
  else
  {
#ifdef DEBUG_MAIL_LOGIC
    Serial.println(F("No Mails."));
#endif
  }    
  
  myGLCD.setColor(0, 0, 0);  
  myGLCD.fillRect(180, 224, 319, 239);      
  return true;
}



int len_of_key_from = 7;
int len_of_key_body = 7;
int len_of_key_att = 12;


String clean_part_of_image( String poi )
{
 #ifdef DEBUG_MAIL_LOGIC_2
  Serial.println(F("UNCLEAN STR"));Serial.print(poi);
 #endif   
  String clean_str = "";
  int start_i = poi.indexOf('%');
  int end_i = -1;  
  if( start_i > -1 )
    end_i = poi.indexOf('F');
    
  while( end_i > 0 )
  {
    clean_str += poi.substring(start_i+1, end_i+1);
    poi = poi.substring(end_i+1);
    start_i = poi.indexOf('%');
    end_i = -1;
    if( start_i > -1 )
      end_i = poi.indexOf('F');    
  }    
 #ifdef DEBUG_MAIL_LOGIC_2
  Serial.println(F("CLEAN STR"));Serial.println(clean_str);
 #endif   
  return clean_str;
}


void clean_mail_txt( String& mailtext )
{
#ifdef DEBUG_MAIL_LOGIC_2
    Serial.println(F("CLEANNING MAIL TEXT "));
#endif    
  mailtext.replace("\nOK", "");
  mailtext.replace("\n", "");
  mailtext.trim();
  int start_i = -1, end_i = -2;
  start_i = mailtext.indexOf("+IPD");
  end_i = (mailtext.substring(start_i)).indexOf(':') + 1;
  while ( end_i > -1 )
  {
    mailtext.remove(start_i, end_i);
    end_i = -1;
    start_i = mailtext.indexOf("+IPD");
    if( start_i > 0 )
      end_i = (mailtext.substring(start_i)).indexOf(':') + 1;
#ifdef DEBUG_MAIL_LOGIC_2
    Serial.print(F(" clean_str: ")); Serial.println(mailtext);
#endif    
  }
}

boolean DecodeMails( int who_ask_index )
{
  File fileptr;
  String onemail = "";
  String attchment = "";
  int found_mails = 0;
  
 #ifdef DEBUG_MAIL_LOGIC 
  Serial.println(F("*********************************\n    Decoding Mails received\n*********************************"));
 #endif 
  if ( SD.exists( MAILSFILE ) )
  {
    fileptr = SD.open(MAILSFILE);
    if( fileptr )
    {
     #ifdef DEBUG_SD 
      Serial.print(F("File opened. "));
      Serial.print(F("Size:")); Serial.println(fileptr.size());
     #endif
    } 
    
    onemail = "";
    attchment = "";
    while( fileptr.available() )
    {
      onemail += (char)fileptr.read();
      if( onemail.lastIndexOf("_ATTACHMENT: ") > -1 )  //END OF ONE MAIL
      {       
       #ifdef DEBUG_MAIL_LOGIC_2 
        Serial.println(F("__________ATTCHEMNT FOUND"));
       #endif 
        int test_cnt = 4;
        while ( fileptr.available() && (test_cnt--) > 0)
        {
          attchment +=  (char)fileptr.read();
        }
        
        if( attchment.lastIndexOf("SIZE") > -1 )
        {          
          char att_name[30];
          get_att_name( att_name );          
          onemail += att_name;
#ifdef DEBUG_MAIL_LOGIC
          Serial.print(F("Mail with attachment. Att name created -> ")); Serial.println(att_name);
#endif
          clean_mail_txt( onemail );
          const int size_of_onemail = onemail.length();
          char mess[size_of_onemail + 2];
          onemail.toCharArray(mess,size_of_onemail+1);   
         #ifdef DEBUG_MAIL_LOGIC_2 
          Serial.println(F("MESS TO DECODE")); Serial.print(onemail);
          Serial.print(F(" --> ")); Serial.println(mess);
         #endif 
          //DecodeOneMail( who_ask_index, mess);  //do this after creating image file
          onemail = "";
          
          char c_infile = ' ';
          while ( fileptr.available() && c_infile!= '@' )
          {
            Serial.print(c_infile);
            c_infile = (char)fileptr.read();
          }
            
         #ifdef DEBUG_MAIL_LOGIC
          Serial.print(F("\nCreating attchment file "));  Serial.println(att_name);
         #endif 
          File att_file = SD.open(att_name, FILE_WRITE);
        #ifdef DEBUG_MAIL_LOGIC
          if( att_file )
            Serial.println(F(".............Created"));
         #endif          
         
          found_mails++;
          String end_of_mess = "";
          boolean eom = false;
          String att_text = "";
          
         // int current_mail_file_pos = fileptr.position();
         //  Serial.println(F(" File Position "));  Serial.println(current_mail_file_pos);
          while ( fileptr.available() && !eom )
          {
            c_infile = (char)fileptr.read();
            att_text += c_infile;      
            if( c_infile == '\n' || c_infile == ' ' || c_infile == '#')
            {
              int i_from = att_text.indexOf("_FROM: ");
              int i_fin = att_text.indexOf("Finnished#");
              if(  i_from > 0 || i_fin > 0 )
                eom = true;
                
              if( i_from < 0 && i_fin < 0)  
              { 
                att_file.print(clean_part_of_image(att_text));
              }
              else  
              {
                int index_stop = max(i_from, i_fin);
                att_file.print(clean_part_of_image(att_text.substring(0, index_stop)));
                onemail= att_text.substring(index_stop);
               #ifdef DEBUG_MAIL_LOGIC 
                Serial.println(F("ONEMAIL NOW "));  Serial.println(onemail);
               #endif 
              }               
              att_text = "";
            }
          }
          int size_of_saved_file = att_file.size();
          att_file.close();
          DecodeOneMail( who_ask_index, mess, size_of_saved_file);                   
        }
        else if( attchment.lastIndexOf("_FRO") > -1 )
        {
          clean_mail_txt( onemail );
          const int size_of_onemail = onemail.length();
          char mess[size_of_onemail + 2];
          onemail.toCharArray(mess,size_of_onemail+1);     
         #ifdef DEBUG_MAIL_LOGIC_2 
          Serial.println(F("MESS TO DECODE"));Serial.print(onemail);Serial.print(F(" --> "));Serial.println(mess);          
         #endif 
          DecodeOneMail( who_ask_index, mess, -1);
          onemail = attchment;
          found_mails++;
        }
        else //Last mail without attachment
        { 
          clean_mail_txt( onemail );
          const int size_of_onemail = onemail.length();
          char mess[size_of_onemail + 2];
          onemail.toCharArray(mess,size_of_onemail+1);     
         #ifdef DEBUG_MAIL_LOGIC_2 
          Serial.println(F("MESS TO DECODE"));Serial.print(onemail);Serial.print(F(" --> "));Serial.println(mess);          
         #endif 
          DecodeOneMail( who_ask_index, mess, -1);
          onemail = "";
          found_mails++;          
        }
        attchment = "";

      }
    }
    fileptr.close();
    //SD.remove(MAILSFILE);
  }
  else
    Serial.print(F("File not found\n"));    
    
 #ifdef DEBUG_MAIL_LOGIC
  Serial.print(F("Mails found now -> ")); Serial.println(found_mails);
 #endif      
  if( found_mails > 0 )
    newmail = true;
    
 #ifdef DEBUG_MAIL_LOGIC
  Serial.print(F("NEWMAIL -> ")); Serial.println(newmail);
 #endif          
  return (found_mails>0);  
}


void get_att_name( char* _new_name )
{
  for(int i=0; i<200;i++)
  {
    char new_name[25];
    sprintf(new_name, "/att/image%d.txt", i);
    if( !SD.exists(new_name) )
    {
      strcpy(_new_name, new_name);
      return;
    }
  }
  for(int i=0; i<200;i++)
  {
    char new_name[25];
    sprintf(new_name, "/att/image%d.txt", i);    
    SD.remove( new_name );
  }
  strcpy(_new_name, "/att/image0.txt" );
  return;  
}



void DecodeOneMail( int who_ask_index, char * p_str_mail, int size_of_att_file )
{   
 #ifdef DEBUG_MAIL_LOGIC_2
      Serial.print(F("TEXT TO DECODE -> "));Serial.println(p_str_mail);    
 #endif      
      char * p_start_of_body = strstr(p_str_mail,"_BODY: ");
      const int size_of_from = strlen(p_str_mail)-strlen(p_start_of_body)-len_of_key_from;
      char mail_from[size_of_from+2];
      strncpy(mail_from, p_str_mail+len_of_key_from, size_of_from);
      mail_from[size_of_from] = '\0';
      for(int i=0;i<size_of_from;i++)
        if( mail_from[i] == '\n' )
          mail_from[i] = ' ';
 #ifdef DEBUG_MAIL_LOGIC_2
      Serial.print(F("pt_FROM -> "));Serial.println(mail_from);    
 #endif          
      SetNameForFrom( mail_from );
      
      char *p_end_of_body =  strstr(p_str_mail,"_ATTACHMENT:");
 #ifdef DEBUG_MAIL_LOGIC
      Serial.print(F("REST AFTER ATT -> "));
      if( p_end_of_body != NULL )
        Serial.println(p_end_of_body);    
      else
       Serial.println(F("NIX"));  
 #endif      
      const int size_of_body = strlen(p_start_of_body)-strlen(p_end_of_body) - len_of_key_body;
      char mail_body[size_of_body+2];
      strncpy( mail_body, p_start_of_body+len_of_key_body, size_of_body );
      mail_body[size_of_body]='\0';
 #ifdef DEBUG_MAIL_LOGIC_2
      Serial.print(F("pt_BODY -> "));Serial.println(mail_body);    
 #endif
      
      char *p_next = mail_body;
      while( p_next != NULL )
      {
        char *p_n = strstr(p_next, "\nOK");
        if( p_n != NULL )
        {
          p_n[0]=p_n[1]=p_n[2]='\n';
          p_next = p_n+3;
        }
        else
          p_next = NULL;
        
      }
      for(int i=0;i<size_of_body;i++)
        if( mail_body[i] == '\n' )
          mail_from[i] = ' ';      

      for (int i = 0; i < size_of_body;i++)
      {
        char c[2];
        c[0] = mail_body[i];
        c[1] = '\0';
        boolean symbol = (strstr(poss_key, c)==NULL)?false:true;
            if( ! ( (mail_body[i] >= '0' && mail_body[i] <= '9')
                || (mail_body[i] >= 'A' && mail_body[i] <= 'z')
                    || symbol ) ) 
                {
                    mail_body[i] = ' ';
                }
      }
 #ifdef DEBUG_MAIL_LOGIC_2
      Serial.print(F("pt_BODY -> "));Serial.println(mail_body);    
 #endif                   
      char *p_start_of_att = strstr(p_end_of_body, ": ");
      const int size_of_att = (p_start_of_att==NULL)?0:strlen(p_start_of_att+2);      
      if( p_start_of_att == NULL )
      {
 #ifdef DEBUG_MAIL_LOGIC_2
      Serial.print(F("pt_ATT -> NULL"));
 #endif                   
      }
      else
      {
        p_start_of_att += 2;
 #ifdef DEBUG_MAIL_LOGIC_2
        Serial.print(F("pt_ATT SIZE-> "));Serial.println(size_of_att);
 #endif                   
      }
     
      char mail_att[size_of_att+2];
      if( size_of_att == 0 )
        mail_att[0] = '\0';
      else
        strncpy( mail_att, p_start_of_att , size_of_att);
      mail_att[size_of_att] = '\0';  
 #ifdef DEBUG_MAIL_LOGIC_2
      Serial.print(F("pt_ATT -> "));Serial.println(mail_att);    
 #endif
      

 #ifdef DEBUG_MAIL_LOGIC
  Serial.print(F("Message decoded:"));
  Serial.print(F("FROM -> ")); Serial.println(mail_from);
  Serial.print(F("BODY ->  ")); Serial.println(mail_body);
  Serial.print(F("ATTACHMENT -> ")); Serial.println(mail_att);
 #endif        
      
      if( strlen(mail_body) > 1 && strlen(mail_from) > 1 )
      {
        if( size_of_att_file < 1 )
          mail_att[0] = '\0';
        write_to_inbox( who_ask_index, mail_body, mail_from, mail_att);      
      }
}  
  
void SetNameForFrom( char *mail_from )
{
  if( strstr(mail_from, "jesus") != NULL )
    strcpy( mail_from, "Mama" );
  else if( strstr(mail_from, "andreas") != NULL )  
    strcpy( mail_from, "Papa" );  
  else if( strstr(mail_from, "eanu") != NULL )  
    strcpy( mail_from, "Keanu" );  
  else if( strstr(mail_from, "amira") != NULL )  
    strcpy( mail_from, "Samira" );  
  else if( strstr(mail_from, "ilian") != NULL )  
    strcpy( mail_from, "Kilian" );  
  else if( strstr(mail_from, "lucienne") != NULL )  
    strcpy( mail_from, "Mami" );      
}
  
  
  
void debug_mails_saved( )
{
 #ifdef DEBUG_MAIL_LOGIC
  Serial.print(F("\n__________________________________________"));
  Serial.print(F("\nMails von ")); Serial.println( key_sendername[sendername_index] );
  for(int j=0;j< MAX_MAILS;j++)
  {    
    if( mails.mail_array[j].mail_text.length() > 0 )
    {
      Serial.print(F("\nMail "));Serial.print(j+1);Serial.print(F(": "));
      Serial.print(F("\n\tFrom: "));Serial.print(mails.mail_array[j].from);
      Serial.print(F("\n\tText: "));Serial.print(mails.mail_array[j].mail_text);
      Serial.print(F("\n\tAttachment: "));Serial.print(mails.mail_array[j].att_file_name);
    }
  }
  Serial.print(F("\n__________________________________________\n\n"));
 #endif 
  
}  


void ResetMailRAM()
{ 
  #ifdef DEBUG_MAIL_LOGIC
   Serial.println(F("\nReseting MAIL_RAM"));
  #endif
  
  for( int i=0-1; i<MAX_MAILS;i++)
  {
    mails.mail_array[i].mail_text = "";
    mails.mail_array[i].from = "";
    mails.mail_array[i].att_file_name = "";    
  }  
}

boolean SaveMail_RAM( String& t, String& a, String& f)
{
 #ifdef DEBUG_MAIL_LOGIC_2
  Serial.print(F("\nSaveMail_RAM(): Saving Mail in RAM for ")); Serial.println(key_sendername[mail_for_userindex]);
  Serial.print(F("Text: "));Serial.println(t);
  Serial.print(F("From: "));Serial.println(f);
  Serial.print(F("Att: "));Serial.println(a);
 #endif
 

  for( int i=MAX_MAILS-1; i>0;i--)
  {
    mails.mail_array[i].mail_text = mails.mail_array[i-1].mail_text;
    mails.mail_array[i].from = mails.mail_array[i-1].from;
    mails.mail_array[i].att_file_name = mails.mail_array[i-1].att_file_name;    
  }

  mails.mail_array[0].mail_text=t;  
  mails.mail_array[0].mail_text.trim();  
  mails.mail_array[0].att_file_name=a;
  mails.mail_array[0].att_file_name.trim();  
  mails.mail_array[0].from = f;
  mails.mail_array[0].from.trim();
  
 #ifdef DEBUG_MAIL_LOGIC_2
  Serial.print(F("SaveMail_RAM(): \n\tSaved text: ")); 
  Serial.println(mails.mail_array[0].mail_text);
  Serial.print(F("\tSaved from: ")); 
  Serial.println(mails.mail_array[0].from);
  Serial.print(F("\tSaved attachment: "));
  Serial.println( mails.mail_array[0].att_file_name);
 #endif
 
 if( (mails.mail_array[0].mail_text.length() > 0 && t.length()>0 )
     && (mails.mail_array[0].from.length() > 0 && f.length()>0 ) )
     return true;
 else
    return false; 

}
  
/***********************************************  SD CARD ***********************************************/
void read_inbox_for_all ( )
{
  for( int i =0; i< SENDER_CNT;i++ )
  {
    read_inbox( i );
    delay(100);
  }    
}
void read_inbox( int  user )
{
  ResetMailRAM();
  char inbox_filename[200] = {};
  sprintf(inbox_filename, "inbox%d.txt", user /*key_sendername[user]*/);
  inbox[user] = SD.open(inbox_filename);
 #ifdef DEBUG_MAIL_LOGIC
  Serial.print(F("\n\nReading Mailbox for ")); Serial.println(user);
 #endif             
  
  if (inbox[user]) 
  {
    Serial.print(F("Reading ")); Serial.println(inbox_filename);    
    // read from the file until there's nothing else in it:
    String word_read = "";
    String mail_read = "";
    String att_read = "";
    int len_of_key_from = 7;
    int len_of_key_body = 7;
    int len_of_key_att = 12;    
    
    while (inbox[user].available()) 
    {
        char c_read = inbox[user].read();
       #ifdef DEBUG_MAIL_LOGIC_2 
    	Serial.write( c_read );
       #endif
        word_read += c_read;
        mail_read += c_read;
        if( c_read == ' ' || c_read == '\n' || c_read == '\0' )
        {
          //int neumail_found = word_read.indexOf("_NEU_MAIL_");
          int neumail_found = word_read.indexOf("_END_OF_NEU_MAIL_");
          
          word_read = "";    
          if( neumail_found > -1 )
          {  
            int neumail_found_in_mail = mail_read.indexOf("_END_OF_NEU_MAIL_");
            String mail_found = mail_read.substring( 0, neumail_found_in_mail );     
            
           #ifdef DEBUG_MAIL_LOGIC_2
            Serial.println(F("_NEU_MAIL_WAS_FOUND   Text("));Serial.print(mail_found.length());
            Serial.print(F(") :"));
            Serial.println(mail_found);
           #endif             
           
            if( mail_found.length() > 1 )
            {              
              if( mail_found.length()>0 /*&& mail_found.indexOf("De:")>0 */)   
              {
                int start_of_from = mail_found.indexOf("_FROM: ");
                int start_of_body = mail_found.indexOf("_BODY: ");
                String mail_from = mail_found.substring( start_of_from+len_of_key_from, start_of_body);
                mail_from.replace("\n", " ");
                mail_from.replace("<br>", ""); 
                int end_of_body = mail_found.indexOf("_ATTACHMENT: ");
                String mail_body = mail_found.substring(start_of_body+len_of_key_body, end_of_body);        
                mail_body.replace("<br>", "\n");  
                mail_body.replace("\nOK\n", " "); 
                mail_body.replace("\n", " "); 
                int start_of_att = mail_found.indexOf("_ATTACHMENT: ");
                String mail_att = mail_found.substring(end_of_body+len_of_key_att);

                //Take a look if the mails contains only white spaces
                String is_text_in_mail = mail_body;
                is_text_in_mail.replace(" ", "");
                //If it is so, is_text_in_mail will have now size 0                
          
    #ifdef DEBUG_MAIL_LOGIC_2
      Serial.print(F("Mail From->"));Serial.println(mail_from);
      Serial.print(F("Mail Body->"));Serial.println(mail_body);      
      Serial.print(F("Mail Att->"));Serial.println(mail_att);      
      Serial.print(F("SIZE oF BODY "));Serial.println(is_text_in_mail.length());      
    #endif                          
           
                if( is_text_in_mail.length() > 0 )
                {
                  if( SaveMail_RAM( mail_body, mail_att, mail_from) == false )
                    Serial.println(F("ERROR saving mail in RAM!"));
                }
              }
            }            
            mail_read = "";
          }          
          
        }
          
    }
    // close the file:
    inbox[user].close();
    debug_mails_saved( );
  } 
  else 
  {
    Serial.print(F("Creating ")); Serial.print(inbox_filename);
    inbox[user] = SD.open(inbox_filename, FILE_WRITE);
    if( inbox[user])
    {
      Serial.println(F("......DONE"));
      inbox[user].close();
    }
    else 
      Serial.println(F("......ERROR"));
  }  
}
 
#define I_X 0 
#define I_Y 1
#define I_B 2
#define I_C 3
void paint_pixel( char* pixel_info, int x1, int y1, int x2, int y2, 
                  int& last_x, int& last_y, int& last_b, int& last_c )
{
 #ifdef DEBUG_SD_2 
  Serial.print(F("\nTEXT: "));Serial.println(pixel_info);
 #endif
 
  int xv=-1, yv=-1, colorv=-1, brushv=-1;
  int pos_index = -1;

  int values[4]={-1,-1,-1,-1};
  int last_values[]={last_x, last_y, last_b, last_c};

  String str_info_pixel = pixel_info;
  int cnt_indx=0;

  while( cnt_indx < 4)
  {
    int indx1 = str_info_pixel.indexOf('-');
    String field = "";
    if( indx1 > -1 )
      field = str_info_pixel.substring(0, indx1);
    else
      field = str_info_pixel;
  #ifdef DEBUG_SD_2
    Serial.print( F("  FIELD "));
    Serial.print(cnt_indx);
    Serial.print(F(" -> "));
    Serial.print(field);
    Serial.print(F("\t"));
  #endif  

    if( field.length() > 0 )
    {
      values[cnt_indx] = field.toInt();
      int new_color = values[cnt_indx];
      if( cnt_indx == I_C )
      {
        if( values[cnt_indx] >= 0 && values[cnt_indx] < 8 )
          myGLCD.setColor(colorlist[new_color]);
      }    
    }
    else
      values[cnt_indx] = last_values[cnt_indx];

    str_info_pixel = str_info_pixel.substring(indx1+1);
    if( str_info_pixel.length() == 0 || indx1<0)
        cnt_indx = 4;
    cnt_indx++;
  }

  xv=(values[0]>=0)?values[0]:last_values[0];
  yv=(values[1]>=0)?values[1]:last_values[1];
  brushv=(values[2]>=0)?values[2]:last_values[2];
  colorv=(values[3]>=0)?values[3]:last_values[3];
  
  if( brushv > 7 || xv > 319 || yv > 239 )
    return;
    
  last_x = xv;
  last_y = yv;
  last_b = brushv;
  last_c = colorv;  

  float scalx = (x2-x1) / 320.0;
  float scaly = (y2-y1) / 240.0;
  int new_xv = x1 + (int)xv*scalx;
  int new_yv = y1 + (int)yv*scaly;
 #ifdef DEBUG_SD_2
  Serial.print(F("  OldY:"));Serial.print(yv); Serial.print(F("  Y:"));Serial.println(new_yv); 
  Serial.print(F("ScalX:"));Serial.print(scalx); 
  Serial.print(F("  ScalY:"));Serial.print(scaly); 
  Serial.print(F("  OldX:"));Serial.print(xv); Serial.print(F("  X:"));Serial.print(new_xv); 
  Serial.print(F("  OldY:"));Serial.print(yv); Serial.print(F("  Y:"));Serial.println(new_yv); 
#endif  

  if( brushv == 1 || scalx < 0.7 )
    myGLCD.drawPixel(new_xv, new_yv);
  else
    myGLCD.fillCircle(new_xv, new_yv, brushv);
}
 
void read_txt_file( char* filename )
{
  File fileptr;
  if( SD.exists( filename ) )
  { 
    fileptr = SD.open(filename);
    if( fileptr )
    {
     #ifdef DEBUG_SD 
      Serial.print(F("File opened. "));
      Serial.print(F("Size:")); Serial.println(fileptr.size());
     #endif
    } 
    while( fileptr.available() )
      Serial.print( (char)fileptr.read() );
  }
  else
    Serial.print(F("File not found\n"));  
}

bool read_image_file( char* image_filename, int what, int x1, int y1, int x2, int y2, bool clean )
{
  File image_ptr;
  if( SD.exists( image_filename ) )
  {
    if( (what == ONLY_DRAW || what == DRAW_PRINT) && clean )
      myGLCD.clrScr();
    image_ptr = SD.open(image_filename);
    if( image_ptr )
    {
     #ifdef DEBUG_SD 
      Serial.print(F("Image opened. "));
      Serial.print(F("Size:")); Serial.println(image_ptr.size());
     #endif
    } 
    else 
    {
     #ifdef DEBUG_SD_2 
      //Serial.println(F("Removing Image."));      
     #endif 
      //SD.remove(image_filename);
      return false;
    }
    int i=0;
    char pixel_info[30];
    pixel_info[0] ='\0';
    int k = 0;
    int lx = -1, ly = -1, lb = 4, lc = 0; 
    while( image_ptr.available() )
    {      
      char c_read = image_ptr.read();
      
      if( c_read == 'F' )
      {
       #ifdef DEBUG_SD_2
        Serial.print(F("F -> "));Serial.print(pixel_info);
       #endif 
        pixel_info[k] ='\0';
        if( what == ONLY_DRAW || what == DRAW_PRINT )
          paint_pixel( pixel_info, x1, y1, x2, y2, lx, ly, lb, lc );
        else if( what == ONLY_PRINT  || what == DRAW_PRINT)
          Serial.print(pixel_info);
        pixel_info[0] ='\0';
        k=0;
      }
      else
      {
        if( k == 29 )
          k=0;
        pixel_info[k++] = c_read;    
      }
    }
    image_ptr.close();
  }
  else
    Serial.print(F("Image not found\n"));
 #ifdef DEBUG_SD_2 
  Serial.print(F("Done."));
 #endif    
 return true;
} 
 
void write_to_inbox( int user,  char* mail_text, char *mail_from, char *mail_att )
{
  char inbox_filename[200] = {};
  Serial.println(F("Writting Inbox\n"));
  char saved_filename[50];
  int size_of_att = strlen(mail_att);
  mail_att[size_of_att] = '\0';
  
  sprintf(inbox_filename, "inbox%d.txt", user /*key_sendername[user]*/);
  Serial.print(F("Opening for write file "));Serial.println(inbox_filename);
  inbox[user] = SD.open(inbox_filename, FILE_WRITE);
  if( inbox[user] == true )
  {
    Serial.print(F("Saving Mail in file "));Serial.println(inbox_filename);
    inbox[user].print("_NEU_MAIL_ ");
    inbox[user].println("_FROM: ");
    inbox[user].println(mail_from);
    Serial.print(F("Writting FROM: ")); Serial.println(mail_from);    
    inbox[user].println("_BODY: ");
    inbox[user].println(mail_text);
    Serial.print(F("Writting BODY: ")); Serial.println(mail_text);        
    inbox[user].println("_ATTACHMENT: ");
    if( strlen(mail_att) > 0 )
    {
      inbox[user].println(mail_att);
      Serial.print(F("Writting ATT: ")); Serial.print(mail_att);Serial.println(F("."));    
    }    
    inbox[user].print("_END_OF_NEU_MAIL_ ");
    inbox[user].close();  
  }
  else 
    Serial.println(F("Saving Mail......ERROR"));
    
}  
  
#define MAX_CNT_IMAGES 60  
int get_file_index(  )
{
  int index_now=-1;
  char file_name[100] = {};
  File info;
  if( SD.exists( info_file ) )
  {
    info = SD.open(info_file);
    int i=0;
    while( info.available() )
    {
       char c_read = info.read();
       file_name[i++]=c_read;      
    }
    file_name[i]='\0';
    sscanf( file_name, "image%d.txt", &index_now);
   #ifdef DEBUG_PAINT_APP    
    Serial.print(F("info.txt contains : "));Serial.println(file_name); 
    Serial.print(F("Index found: "));Serial.println(index_now);
   #endif                
  }
  else
  {
    info=SD.open( "info.txt", FILE_WRITE);
   #ifdef DEBUG_PAINT_APP    
    Serial.print(F("Creating file "));Serial.print(info_file);
    if( info )
      Serial.println(F("... ERROR"));    
   #endif
  }
    
    
  info.close();
  
  index_now++;
  if( index_now >= 60 )
    index_now = 0;
  return index_now;
}


int last_X = -1;
int last_Y = -1;
void save_xy( int _X, int _Y, int _B, int _Color )
{
  if( _B > 2 )
    if( last_X!=-1 && abs(_X-last_X) < 4 && last_Y!=-1 && abs(_Y-last_Y) < 4 )
       return;  
  
  if( curr_image == false )
  {
    boolean created = make_new_image( );
   #ifdef DEBUG_PAINT_APP        
    if( !created )
      Serial.println(F("ERROR saving image"));
    else   
      Serial.println(F("Current Image File created"));
   #endif   
  }
  
  if( curr_image == true )
  {
    char save_str[20];
    save_str[0] = '\0';
    if( last_used_color != _Color )
    {
      sprintf(save_str, "%d-%d-%d-%dF", _X,_Y,_B,_Color);
      last_used_color = _Color;
    }
    else
      sprintf(save_str, "%d-%d-%dF", _X,_Y,_B);
    
    if( curr_image.size() < 3650 ) 
    {
      curr_image.print(save_str);
      curr_image.flush();
    }
    else 
      Serial.println(F("Image too big. End of saving."));  
    
    int curr_color = myGLCD.getColor();
    myGLCD.setColor(VGA_WHITE);
    if( curr_image.size() > 3500 )
      myGLCD.setColor(VGA_RED);  
    else if( curr_image.size() > 2700 )
      myGLCD.setColor(VGA_GREEN);
    else if( curr_image.size() > 2000 )
      myGLCD.setColor(VGA_AQUA);            
    else if( curr_image.size() > 1000 )
      myGLCD.setColor(VGA_YELLOW); 
      
    myGLCD.fillRect(myGLCD.getDisplayXSize()-32,96,myGLCD.getDisplayXSize()-1,128); 
    myGLCD.setColor(curr_color);
    
   #ifdef DEBUG_PAINT_APP   
    Serial.print(save_str);
   #endif 
  }
  last_X = _X;
  last_Y = _Y;  
}

boolean make_new_image( )
{
  int index_now = get_file_index( );
  /*
  if( !SD.exists("imagesdir") )
    SD.mkdir("imagesdir");
  */  
  char new_file_name[15];
  sprintf(new_file_name, "image%d.txt", index_now);
 #ifdef DEBUG_PAINT_APP    
  Serial.print(F("New Image File Name: "));Serial.println(new_file_name);
 #endif    
  File ii = SD.open( new_file_name );
  if ( ii == true )
  {
    ii.close();
    SD.remove(new_file_name);    
  }
  curr_image = SD.open(new_file_name, FILE_WRITE);
  if( curr_image == true )
  {
   #ifdef DEBUG_PAINT_APP    
     Serial.print(F("New Image File created: "));Serial.println(new_file_name);
   #endif  
    curr_image_index = index_now;
    return true;
  }
  else
  {
    #ifdef DEBUG_PAINT_APP    
     Serial.print(F("Error creating image file "));Serial.println(new_file_name);
    #endif      
    return false;  
  }
}

void close_image( boolean force )
{
  if( curr_image == true )
  {
    if( curr_image.size() > 30 || force == true )
    {
      char fn[10];
      sprintf(fn, "image%d.txt", curr_image_index);
      if( force == false )
        update_imageinfo( fn );   
    #ifdef DEBUG_PAINT_APP    
     Serial.print(F("Current image has a size of "));Serial.println(curr_image.size());
     Serial.println(F("Closing current image file"));
    #endif                  
      curr_image.close();
    }      
  }
}

void update_imageinfo( char *last_image_name )
{
  SD.remove("info.txt");
  delay(30);
  File ii = SD.open("info.txt", FILE_WRITE);
  if( ii == true )
  {
   #ifdef DEBUG_PAINT_APP    
    Serial.print(F("Updating imageinfo.txt. Last file now is "));Serial.println(last_image_name);    
   #endif 
    ii.println(last_image_name);  
    ii.close();
    strcpy( image_to_send, last_image_name );
  }
  else
  {
   #ifdef DEBUG_PAINT_APP    
    Serial.print(F("Error opening file infoinfo.txt"));
   #endif     
  }
}
 


void errorHalt(String msg)
{
  #ifdef DEBUG
    Serial.println(msg);
    Serial.println(F("HALT"));
  #endif
  //while(true){};
}

// Read characters from WiFi module and echo to serial until keyword occurs or timeout.
boolean echoFind(String& keyword)
{
  byte current_char   = 0;
  byte keyword_length = keyword.length();
  
  // Fail if the target string has not been sent by deadline.
  long deadline = millis() + TIMEOUT;
  while(millis() < deadline)
  {
    if (Serial3.available())
    {
      char ch = Serial3.read();
      #ifdef DEBUG
        Serial.write(ch);
      #endif
      if (ch == keyword[current_char])
        if (++current_char == keyword_length)
        {
          #ifdef DEBUG
            Serial.println();
          #endif
          return true;
        }
    }
  }
  return false;  // Timed out
}

// Read and echo all available module output.
// (Used when we're indifferent to "OK" vs. "no change" responses or to get around firmware bugs.)
void echoFlush()
{
  while (Serial3.available()) Serial.write(Serial3.read());
}
  
// Echo module output until 3 newlines encountered.
// (Used when we're indifferent to "OK" vs. "no change" responses.)
void echoSkip()
{
  String cr_ = "\n";
  echoFind(cr_);        // Search for nl at end of command echo
  echoFind(cr_);        // Search for 2nd nl at end of response.
  echoFind(cr_);        // Search for 3rd nl at end of blank line.
}

// Send a command to the module and wait for acknowledgement string
// (or flush module output if no ack specified).
// Echoes all data received to the serial monitor.
boolean echoCommand(String cmd, String ack, boolean halt_on_fail)
{
  Serial3.println(cmd);
  #ifdef ECHO_COMMANDS
    Serial.print("--"); Serial.println(cmd);
  #endif
  
  // If no ack response specified, skip all available module output.
  if (ack == "")
    echoSkip();
  else
    // Otherwise wait for ack.
    if (!echoFind(ack))          // timed out waiting for ack string 
      if (halt_on_fail)
        errorHalt(cmd+" failed");// Critical failure halt.
      else
        return false;            // Let the caller handle it.
  return true;                   // ack blank or ack found
}

// Connect to the specified wireless network.
boolean connectWiFi( int where )
{
  String cmd = "";
  if( where == WHERE_CASA )
  {
    cmd = "AT+CWJAP=\""; cmd += SSID_HOME; cmd += "\",\""; cmd += PASS_HOME; cmd += "\"";
  }
  else  
    cmd = "AT+CWJAP=\""; cmd += SSID_HOT; cmd += "\",\""; cmd += PASS_HOT; cmd += "\"";  
  if (echoCommand(cmd, "OK", CONTINUE)) // Join Access Point
  {
    Serial.print(F("Connected to WiFi-"));Serial.println((where==WHERE_CASA)?"CASA":"HOTSPOT");
    connection_established = true;
    where_connected = where;   
    return true;
  }
  else  //2nd try, ESP8266 needs always 2 tries
  {
    if( where == WHERE_CASA )
    {
      cmd = "AT+CWJAP=\""; cmd += SSID_HOME; cmd += "\",\""; cmd += PASS_HOME; cmd += "\"";
    }
    else  
      cmd = "AT+CWJAP=\""; cmd += SSID_HOT; cmd += "\",\""; cmd += PASS_HOT; cmd += "\"";      
    if ( !echoCommand(cmd, "OK", CONTINUE))  
    {
      Serial.print(F("Connection to WiFi-" )); Serial.print((where==WHERE_CASA)?"CASA":"HOTSPOT");
      Serial.println(F(" failed."));
      connection_established = false;
      where_connected = -1;
      return false;
    }
    else
    {
      Serial.print(F("Connected to WiFi-"));Serial.println((where==WHERE_CASA)?"CASA":"HOTSPOT");
      connection_established = true; 
      where_connected = where;   
      return true;      
    }  
  }
}

void check_connection( )
{ 
  if (!echoCommand("AT+CIPSTATUS", "OK", CONTINUE)) 
  {
 #ifdef DEBUG_MAIL_LOGIC
     Serial.print(F("TCP connection status failed"));
 #endif       
    connection_established = false;
    //return false;   
  }
  connection_established = true;  
  //if( connectWiFi() == true )
    // connection_established = true;

  DrawConnectionStatus();
}

/*
void set_interrupt_1()
{
  TCCR1B = 0x00;        //Disbale Timer2 while we set it up
  TCNT1  = 130;         //Reset Timer Count to 130 out of 255
  TIFR1  = 0x00;        //Timer2 INT Flag Reg: Clear Timer Overflow Flag
  TIMSK1 = 0x01;        //Timer2 INT Reg: Timer2 Overflow Interrupt Enable
  TCCR1A = 0x00;        //Timer2 Control Reg A: Normal port operation, Wave Gen Mode normal
  TCCR1B = 0x05;    
}
*/

void set_interrupt( unsigned int timercnt )
{
  allow_loop(timercnt);  
  TCCR2B = 0x00;        //Disbale Timer2 while we set it up
  TCNT2  = 130;         //Reset Timer Count to 130 out of 255
  TIFR2  = 0x00;        //Timer2 INT Flag Reg: Clear Timer Overflow Flag
  TIMSK2 = 0x01;        //Timer2 INT Reg: Timer2 Overflow Interrupt Enable
  TCCR2A = 0x00;        //Timer2 Control Reg A: Normal port operation, Wave Gen Mode normal
  TCCR2B = 0x05;     
}
 
  
  
  
//////////////////////////////////   CLOCK    ////////////////////////////////////////


void DrawClockPage( )
{
  ///// TEST////
  t.hour = hour();  //Winter
  t.min = minute();
  t.sec= second();
  t.mon=month();
  t.date=day();
  t.year=year(); 
  //if( t.mon < 11 && t.date < 25 && t.year == 2015 )
    //t.hour += 1;
    
  drawDisplay(t);
  printDate( t );
  boolean print_clock = true;
  if( iPAGE == CLOCK_PAGE )
    print_clock = true;

  while ( print_clock )
  {
    if (oldsec!=t.sec)
    {
      if ((t.sec==0) and (t.min==0) and (t.hour==0))
      {
        clearDate();
        printDate(t);
      }
      if (t.sec==0)
      {
        drawMin(t.min);
        drawHour(t.hour, t.min);
      }
      drawSec(t.sec);
      oldsec=t.sec;
    }
    
    delay(10);
    t.hour = hour();
    t.min = minute();
    t.sec= second();
    t.mon=month();
    t.date=day();
    t.year=year();      
    if (myTouch.dataAvailable())
    {
      myGLCD.setBackColor(0, 0, 255);
      myGLCD.setFont(BigFont);
      letter_font = true;
      print_clock = false;
      change_page( KEYBOARD_PAGE );
      return;
    }
  }
    
}

void drawDisplay(Time& t_temp )
{
  // Clear screen
  myGLCD.clrScr();
  
  // Draw Clockface
  myGLCD.setColor(0, 0, 255);
  myGLCD.setBackColor(0, 0, 0);
  for (int i=0; i<5; i++)
  {
    myGLCD.drawCircle(clockCenterX, clockCenterY, 119-i);
  }
  for (int i=0; i<5; i++)
  {
    myGLCD.drawCircle(clockCenterX, clockCenterY, i);
  }
  
  myGLCD.setColor(192, 192, 255);
  myGLCD.print("3", clockCenterX+92, clockCenterY-8);
  myGLCD.print("6", clockCenterX-8, clockCenterY+95);
  myGLCD.print("9", clockCenterX-109, clockCenterY-8);
  myGLCD.print("12", clockCenterX-16, clockCenterY-109);
  for (int i=0; i<12; i++)
  {
    if ((i % 3)!=0)
      drawMark(i);
  }  
  //t = rtc.getTime();
  drawMin(t_temp.min);
  drawHour(t_temp.hour, t_temp.min);
  drawSec(t_temp.sec);
  oldsec=t_temp.sec;

  // Draw calendar
  myGLCD.setColor(255, 255, 255);
  myGLCD.fillRoundRect(240, 0, 319, 85);
  myGLCD.setColor(0, 0, 0);
  for (int i=0; i<7; i++)
  {
    myGLCD.drawLine(249+(i*10), 0, 248+(i*10), 3);
    myGLCD.drawLine(250+(i*10), 0, 249+(i*10), 3);
    myGLCD.drawLine(251+(i*10), 0, 250+(i*10), 3);
  }

  // Draw SET button
  myGLCD.setColor(64, 64, 128);
  myGLCD.fillRoundRect(260, 200, 319, 239);
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect(260, 200, 319, 239);
  myGLCD.setBackColor(64, 64, 128);
  myGLCD.print("OK", 266, 212);
  myGLCD.setBackColor(0, 0, 0);
}

void drawMark(int h)
{
  float x1, y1, x2, y2;
  
  h=h*30;
  h=h+270;
  
  x1=110*cos(h*0.0175);
  y1=110*sin(h*0.0175);
  x2=100*cos(h*0.0175);
  y2=100*sin(h*0.0175);
  
  myGLCD.drawLine(x1+clockCenterX, y1+clockCenterY, x2+clockCenterX, y2+clockCenterY);
}

void drawSec(int s)
{
  float x1, y1, x2, y2;
  int ps = s-1;
  
  myGLCD.setColor(0, 0, 0);
  if (ps==-1)
    ps=59;
  ps=ps*6;
  ps=ps+270;
  
  x1=95*cos(ps*0.0175);
  y1=95*sin(ps*0.0175);
  x2=80*cos(ps*0.0175);
  y2=80*sin(ps*0.0175);
  
  myGLCD.drawLine(x1+clockCenterX, y1+clockCenterY, x2+clockCenterX, y2+clockCenterY);

  myGLCD.setColor(255, 0, 0);
  s=s*6;
  s=s+270;
  
  x1=95*cos(s*0.0175);
  y1=95*sin(s*0.0175);
  x2=80*cos(s*0.0175);
  y2=80*sin(s*0.0175);
  
  myGLCD.drawLine(x1+clockCenterX, y1+clockCenterY, x2+clockCenterX, y2+clockCenterY);
}

void drawMin(int m)
{
  float x1, y1, x2, y2, x3, y3, x4, y4;
  int pm = m-1;
  
  myGLCD.setColor(0, 0, 0);
  if (pm==-1)
    pm=59;
  pm=pm*6;
  pm=pm+270;
  
  x1=80*cos(pm*0.0175);
  y1=80*sin(pm*0.0175);
  x2=5*cos(pm*0.0175);
  y2=5*sin(pm*0.0175);
  x3=30*cos((pm+4)*0.0175);
  y3=30*sin((pm+4)*0.0175);
  x4=30*cos((pm-4)*0.0175);
  y4=30*sin((pm-4)*0.0175);
  
  myGLCD.drawLine(x1+clockCenterX, y1+clockCenterY, x3+clockCenterX, y3+clockCenterY);
  myGLCD.drawLine(x3+clockCenterX, y3+clockCenterY, x2+clockCenterX, y2+clockCenterY);
  myGLCD.drawLine(x2+clockCenterX, y2+clockCenterY, x4+clockCenterX, y4+clockCenterY);
  myGLCD.drawLine(x4+clockCenterX, y4+clockCenterY, x1+clockCenterX, y1+clockCenterY);

  myGLCD.setColor(0, 255, 0);
  m=m*6;
  m=m+270;
  
  x1=80*cos(m*0.0175);
  y1=80*sin(m*0.0175);
  x2=5*cos(m*0.0175);
  y2=5*sin(m*0.0175);
  x3=30*cos((m+4)*0.0175);
  y3=30*sin((m+4)*0.0175);
  x4=30*cos((m-4)*0.0175);
  y4=30*sin((m-4)*0.0175);
  
  myGLCD.drawLine(x1+clockCenterX, y1+clockCenterY, x3+clockCenterX, y3+clockCenterY);
  myGLCD.drawLine(x3+clockCenterX, y3+clockCenterY, x2+clockCenterX, y2+clockCenterY);
  myGLCD.drawLine(x2+clockCenterX, y2+clockCenterY, x4+clockCenterX, y4+clockCenterY);
  myGLCD.drawLine(x4+clockCenterX, y4+clockCenterY, x1+clockCenterX, y1+clockCenterY);
}

void drawHour(int h, int m)
{
  float x1, y1, x2, y2, x3, y3, x4, y4;
  int ph = h;
  
  myGLCD.setColor(0, 0, 0);
  if (m==0)
  {
    ph=((ph-1)*30)+((m+59)/2);
  }
  else
  {
    ph=(ph*30)+((m-1)/2);
  }
  ph=ph+270;
  
  x1=60*cos(ph*0.0175);
  y1=60*sin(ph*0.0175);
  x2=5*cos(ph*0.0175);
  y2=5*sin(ph*0.0175);
  x3=20*cos((ph+5)*0.0175);
  y3=20*sin((ph+5)*0.0175);
  x4=20*cos((ph-5)*0.0175);
  y4=20*sin((ph-5)*0.0175);
  
  myGLCD.drawLine(x1+clockCenterX, y1+clockCenterY, x3+clockCenterX, y3+clockCenterY);
  myGLCD.drawLine(x3+clockCenterX, y3+clockCenterY, x2+clockCenterX, y2+clockCenterY);
  myGLCD.drawLine(x2+clockCenterX, y2+clockCenterY, x4+clockCenterX, y4+clockCenterY);
  myGLCD.drawLine(x4+clockCenterX, y4+clockCenterY, x1+clockCenterX, y1+clockCenterY);

  myGLCD.setColor(255, 255, 0);
  h=(h*30)+(m/2);
  h=h+270;
  
  x1=60*cos(h*0.0175);
  y1=60*sin(h*0.0175);
  x2=5*cos(h*0.0175);
  y2=5*sin(h*0.0175);
  x3=20*cos((h+5)*0.0175);
  y3=20*sin((h+5)*0.0175);
  x4=20*cos((h-5)*0.0175);
  y4=20*sin((h-5)*0.0175);
  
  myGLCD.drawLine(x1+clockCenterX, y1+clockCenterY, x3+clockCenterX, y3+clockCenterY);
  myGLCD.drawLine(x3+clockCenterX, y3+clockCenterY, x2+clockCenterX, y2+clockCenterY);
  myGLCD.drawLine(x2+clockCenterX, y2+clockCenterY, x4+clockCenterX, y4+clockCenterY);
  myGLCD.drawLine(x4+clockCenterX, y4+clockCenterY, x1+clockCenterX, y1+clockCenterY);
}


char *monthnames[] = {"Jan", "Feb", "Mar", "Apr", "Mai", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dez" };

void printDate( Time& t_temp )
{
//  Time t_temp;
  
  //t_temp = rtc.getTime();
  myGLCD.setFont(BigFont);
  myGLCD.setColor(0, 0, 0);
  myGLCD.setBackColor(255, 255, 255);
  myGLCD.print(rtc.getDOWStr(FORMAT_SHORT), 256, 8);
  if (t_temp.date<10)
    myGLCD.printNumI(t_temp.date, 272, 28);
  else
    myGLCD.printNumI(t_temp.date, 264, 28);
  if( t_temp.mon >= 1 && t_temp.mon <= 12 )
    myGLCD.print(monthnames[t_temp.mon], 256, 48);
  myGLCD.printNumI(t_temp.year, 248, 65);
}

void clearDate()
{
  myGLCD.setColor(255, 255, 255);
  myGLCD.fillRect(248, 8, 312, 81);
}
  
  
  
